 
/***************************************************************

    pdlconv.c
    automatically created by pdlconv.c.PL

****************************************************************/


#define PDL_CORE      /* For certain ifdefs */
#include "pdl.h"      /* Data structure declarations */
#include "pdlcore.h"  /* Core declarations */


void pdl_readdata_vaffine(pdl *a) {
	int i,j;
	int intype = a->datatype;
	if(!PDL_VAFFOK(a)) {
		die("pdl_readdata_vaffine without vaffine");
	}
	PDL_ENSURE_ALLOCATED(a);
	switch ( intype ) {
    case PDL_L:
      {
	PDL_Long *ap = (PDL_Long *) a->data;
	PDL_Long *pp = (PDL_Long *) a->vafftrans->from->data;
	pp += a->vafftrans->offs;
	for(i=0; i<a->nvals; i++) {
	    *ap = *pp;
	    for(j=0; j<a->ndims; j++) {
		pp += a->vafftrans->incs[j];
		if((j < a->ndims - 1 &&
		    (i+1) % a->dimincs[j+1]) ||
		   j == a->ndims - 1)
		    break;
		pp -= a->vafftrans->incs[j] *
		    a->dims[j];
	    }
	    ap ++;
	}
      }
      break;

    case PDL_F:
      {
	PDL_Float *ap = (PDL_Float *) a->data;
	PDL_Float *pp = (PDL_Float *) a->vafftrans->from->data;
	pp += a->vafftrans->offs;
	for(i=0; i<a->nvals; i++) {
	    *ap = *pp;
	    for(j=0; j<a->ndims; j++) {
		pp += a->vafftrans->incs[j];
		if((j < a->ndims - 1 &&
		    (i+1) % a->dimincs[j+1]) ||
		   j == a->ndims - 1)
		    break;
		pp -= a->vafftrans->incs[j] *
		    a->dims[j];
	    }
	    ap ++;
	}
      }
      break;

    case PDL_S:
      {
	PDL_Short *ap = (PDL_Short *) a->data;
	PDL_Short *pp = (PDL_Short *) a->vafftrans->from->data;
	pp += a->vafftrans->offs;
	for(i=0; i<a->nvals; i++) {
	    *ap = *pp;
	    for(j=0; j<a->ndims; j++) {
		pp += a->vafftrans->incs[j];
		if((j < a->ndims - 1 &&
		    (i+1) % a->dimincs[j+1]) ||
		   j == a->ndims - 1)
		    break;
		pp -= a->vafftrans->incs[j] *
		    a->dims[j];
	    }
	    ap ++;
	}
      }
      break;

    case PDL_US:
      {
	PDL_Ushort *ap = (PDL_Ushort *) a->data;
	PDL_Ushort *pp = (PDL_Ushort *) a->vafftrans->from->data;
	pp += a->vafftrans->offs;
	for(i=0; i<a->nvals; i++) {
	    *ap = *pp;
	    for(j=0; j<a->ndims; j++) {
		pp += a->vafftrans->incs[j];
		if((j < a->ndims - 1 &&
		    (i+1) % a->dimincs[j+1]) ||
		   j == a->ndims - 1)
		    break;
		pp -= a->vafftrans->incs[j] *
		    a->dims[j];
	    }
	    ap ++;
	}
      }
      break;

    case PDL_D:
      {
	PDL_Double *ap = (PDL_Double *) a->data;
	PDL_Double *pp = (PDL_Double *) a->vafftrans->from->data;
	pp += a->vafftrans->offs;
	for(i=0; i<a->nvals; i++) {
	    *ap = *pp;
	    for(j=0; j<a->ndims; j++) {
		pp += a->vafftrans->incs[j];
		if((j < a->ndims - 1 &&
		    (i+1) % a->dimincs[j+1]) ||
		   j == a->ndims - 1)
		    break;
		pp -= a->vafftrans->incs[j] *
		    a->dims[j];
	    }
	    ap ++;
	}
      }
      break;

    case PDL_B:
      {
	PDL_Byte *ap = (PDL_Byte *) a->data;
	PDL_Byte *pp = (PDL_Byte *) a->vafftrans->from->data;
	pp += a->vafftrans->offs;
	for(i=0; i<a->nvals; i++) {
	    *ap = *pp;
	    for(j=0; j<a->ndims; j++) {
		pp += a->vafftrans->incs[j];
		if((j < a->ndims - 1 &&
		    (i+1) % a->dimincs[j+1]) ||
		   j == a->ndims - 1)
		    break;
		pp -= a->vafftrans->incs[j] *
		    a->dims[j];
	    }
	    ap ++;
	}
      }
      break;

    case PDL_LL:
      {
	PDL_LongLong *ap = (PDL_LongLong *) a->data;
	PDL_LongLong *pp = (PDL_LongLong *) a->vafftrans->from->data;
	pp += a->vafftrans->offs;
	for(i=0; i<a->nvals; i++) {
	    *ap = *pp;
	    for(j=0; j<a->ndims; j++) {
		pp += a->vafftrans->incs[j];
		if((j < a->ndims - 1 &&
		    (i+1) % a->dimincs[j+1]) ||
		   j == a->ndims - 1)
		    break;
		pp -= a->vafftrans->incs[j] *
		    a->dims[j];
	    }
	    ap ++;
	}
      }
      break;


    } /* switch( intype ) */

/***	free(inds); ***/
}


void pdl_writebackdata_vaffine(pdl *a) {
	int i,j;
	int intype = a->datatype;
	if(!PDL_VAFFOK(a)) {
		die("pdl_writebackdata_vaffine without vaffine");
	}
	PDL_ENSURE_ALLOCATED(a);
	switch ( intype ) {
    case PDL_L:
      {
	PDL_Long *ap = (PDL_Long *) a->data;
	PDL_Long *pp = (PDL_Long *) a->vafftrans->from->data;
	pp += a->vafftrans->offs;
	for(i=0; i<a->nvals; i++) {
	    *pp = *ap;
	    for(j=0; j<a->ndims; j++) {
		pp += a->vafftrans->incs[j];
		if((j < a->ndims - 1 &&
		    (i+1) % a->dimincs[j+1]) ||
		   j == a->ndims - 1)
		    break;
		pp -= a->vafftrans->incs[j] *
		    a->dims[j];
	    }
	    ap ++;
	}
      }
      break;

    case PDL_F:
      {
	PDL_Float *ap = (PDL_Float *) a->data;
	PDL_Float *pp = (PDL_Float *) a->vafftrans->from->data;
	pp += a->vafftrans->offs;
	for(i=0; i<a->nvals; i++) {
	    *pp = *ap;
	    for(j=0; j<a->ndims; j++) {
		pp += a->vafftrans->incs[j];
		if((j < a->ndims - 1 &&
		    (i+1) % a->dimincs[j+1]) ||
		   j == a->ndims - 1)
		    break;
		pp -= a->vafftrans->incs[j] *
		    a->dims[j];
	    }
	    ap ++;
	}
      }
      break;

    case PDL_S:
      {
	PDL_Short *ap = (PDL_Short *) a->data;
	PDL_Short *pp = (PDL_Short *) a->vafftrans->from->data;
	pp += a->vafftrans->offs;
	for(i=0; i<a->nvals; i++) {
	    *pp = *ap;
	    for(j=0; j<a->ndims; j++) {
		pp += a->vafftrans->incs[j];
		if((j < a->ndims - 1 &&
		    (i+1) % a->dimincs[j+1]) ||
		   j == a->ndims - 1)
		    break;
		pp -= a->vafftrans->incs[j] *
		    a->dims[j];
	    }
	    ap ++;
	}
      }
      break;

    case PDL_US:
      {
	PDL_Ushort *ap = (PDL_Ushort *) a->data;
	PDL_Ushort *pp = (PDL_Ushort *) a->vafftrans->from->data;
	pp += a->vafftrans->offs;
	for(i=0; i<a->nvals; i++) {
	    *pp = *ap;
	    for(j=0; j<a->ndims; j++) {
		pp += a->vafftrans->incs[j];
		if((j < a->ndims - 1 &&
		    (i+1) % a->dimincs[j+1]) ||
		   j == a->ndims - 1)
		    break;
		pp -= a->vafftrans->incs[j] *
		    a->dims[j];
	    }
	    ap ++;
	}
      }
      break;

    case PDL_D:
      {
	PDL_Double *ap = (PDL_Double *) a->data;
	PDL_Double *pp = (PDL_Double *) a->vafftrans->from->data;
	pp += a->vafftrans->offs;
	for(i=0; i<a->nvals; i++) {
	    *pp = *ap;
	    for(j=0; j<a->ndims; j++) {
		pp += a->vafftrans->incs[j];
		if((j < a->ndims - 1 &&
		    (i+1) % a->dimincs[j+1]) ||
		   j == a->ndims - 1)
		    break;
		pp -= a->vafftrans->incs[j] *
		    a->dims[j];
	    }
	    ap ++;
	}
      }
      break;

    case PDL_B:
      {
	PDL_Byte *ap = (PDL_Byte *) a->data;
	PDL_Byte *pp = (PDL_Byte *) a->vafftrans->from->data;
	pp += a->vafftrans->offs;
	for(i=0; i<a->nvals; i++) {
	    *pp = *ap;
	    for(j=0; j<a->ndims; j++) {
		pp += a->vafftrans->incs[j];
		if((j < a->ndims - 1 &&
		    (i+1) % a->dimincs[j+1]) ||
		   j == a->ndims - 1)
		    break;
		pp -= a->vafftrans->incs[j] *
		    a->dims[j];
	    }
	    ap ++;
	}
      }
      break;

    case PDL_LL:
      {
	PDL_LongLong *ap = (PDL_LongLong *) a->data;
	PDL_LongLong *pp = (PDL_LongLong *) a->vafftrans->from->data;
	pp += a->vafftrans->offs;
	for(i=0; i<a->nvals; i++) {
	    *pp = *ap;
	    for(j=0; j<a->ndims; j++) {
		pp += a->vafftrans->incs[j];
		if((j < a->ndims - 1 &&
		    (i+1) % a->dimincs[j+1]) ||
		   j == a->ndims - 1)
		    break;
		pp -= a->vafftrans->incs[j] *
		    a->dims[j];
	    }
	    ap ++;
	}
      }
      break;


    } /* switch( intype ) */

/***	free(inds); ***/
}


/* Various conversion utilities for pdl data types */

/* Swap pdls */

void pdl_swap(pdl** a, pdl** b) {
   pdl* tmp;
   tmp = *b; *b=*a; *a=tmp;
}

/* Change the type of all the data in a pdl struct, either changing the
   original perl structure or making a temporary copy  */

/* 
 * it seems this does not have to be aware of bad values
 * (at least in the current scheme)
 */

void pdl_converttype( pdl** aa, int targtype, Logical changePerl ) {
    pdl* a=*aa;  /* Point to cache */
    int intype;
    void* b;     /* Scratch data ptr */
    SV*   bar;
    HV*   hash;
    STRLEN   nbytes;
    int   diffsize;
    int   i;
#if (PERL_VERSION >= 5) && (PERL_SUBVERSION >= 57)
    dXSARGS;
#endif

    PDLDEBUG_f(printf("pdl_converttype %p, %d, %d, %d\n", (void*)a, a->datatype,
    	targtype, changePerl);)

    intype = a->datatype;
    if (intype == targtype)
       return;

    diffsize = pdl_howbig(targtype) != pdl_howbig(a->datatype);

    nbytes = a->nvals * pdl_howbig(targtype); /* Size of converted data */

    if (changePerl) {   /* Grow data */

      if(a->state & PDL_DONTTOUCHDATA) {
	croak("Trying to convert of magical (mmaped?) pdl");
      }

      if (diffsize) {
         b = a->data;                      /* pointer to old data */
         a->data     = pdl_malloc(nbytes); /* Space for changed data */
      }
      else{
         b = a->data; /* In place */
      }

    }else{

       die("Sorry, temporary type casting is not allowed now");

       b = a->data;          /* Ptr to old data */
       a = pdl_tmp();        /* Brand new scratch pdl */
/*       pdl_clone(*aa,  a);  */ /* Copy old pdl entries */
       a->data     = pdl_malloc(nbytes); /* Space for changed data */
       *aa = a;              /* Change passed value to new address */
    }

    /* Do the conversion as nested switch statements */

    switch ( intype ) {
      case PDL_L:
        {
         PDL_Long *bb = (PDL_Long *) b;
         i = a->nvals;
      
         switch ( targtype ) {
	   case PDL_F:
             {
              PDL_Float *aa = (PDL_Float *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Float) *bb--;
             }
             break;

	   case PDL_S:
             {
              PDL_Short *aa = (PDL_Short *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Short) *bb--;
             }
             break;

	   case PDL_US:
             {
              PDL_Ushort *aa = (PDL_Ushort *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Ushort) *bb--;
             }
             break;

	   case PDL_D:
             {
              PDL_Double *aa = (PDL_Double *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Double) *bb--;
             }
             break;

	   case PDL_B:
             {
              PDL_Byte *aa = (PDL_Byte *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Byte) *bb--;
             }
             break;

	   case PDL_LL:
             {
              PDL_LongLong *aa = (PDL_LongLong *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_LongLong) *bb--;
             }
             break;

           default:
             croak("Don't know how to convert datatype PDL_L to #%d", targtype);
         } /* switch targtype */
         break;
        } /* case: PDL_L */

      case PDL_F:
        {
         PDL_Float *bb = (PDL_Float *) b;
         i = a->nvals;
      
         switch ( targtype ) {
	   case PDL_L:
             {
              PDL_Long *aa = (PDL_Long *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Long) *bb--;
             }
             break;

	   case PDL_S:
             {
              PDL_Short *aa = (PDL_Short *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Short) *bb--;
             }
             break;

	   case PDL_US:
             {
              PDL_Ushort *aa = (PDL_Ushort *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Ushort) *bb--;
             }
             break;

	   case PDL_D:
             {
              PDL_Double *aa = (PDL_Double *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Double) *bb--;
             }
             break;

	   case PDL_B:
             {
              PDL_Byte *aa = (PDL_Byte *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Byte) *bb--;
             }
             break;

	   case PDL_LL:
             {
              PDL_LongLong *aa = (PDL_LongLong *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_LongLong) *bb--;
             }
             break;

           default:
             croak("Don't know how to convert datatype PDL_F to #%d", targtype);
         } /* switch targtype */
         break;
        } /* case: PDL_F */

      case PDL_S:
        {
         PDL_Short *bb = (PDL_Short *) b;
         i = a->nvals;
      
         switch ( targtype ) {
	   case PDL_L:
             {
              PDL_Long *aa = (PDL_Long *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Long) *bb--;
             }
             break;

	   case PDL_F:
             {
              PDL_Float *aa = (PDL_Float *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Float) *bb--;
             }
             break;

	   case PDL_US:
             {
              PDL_Ushort *aa = (PDL_Ushort *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Ushort) *bb--;
             }
             break;

	   case PDL_D:
             {
              PDL_Double *aa = (PDL_Double *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Double) *bb--;
             }
             break;

	   case PDL_B:
             {
              PDL_Byte *aa = (PDL_Byte *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Byte) *bb--;
             }
             break;

	   case PDL_LL:
             {
              PDL_LongLong *aa = (PDL_LongLong *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_LongLong) *bb--;
             }
             break;

           default:
             croak("Don't know how to convert datatype PDL_S to #%d", targtype);
         } /* switch targtype */
         break;
        } /* case: PDL_S */

      case PDL_US:
        {
         PDL_Ushort *bb = (PDL_Ushort *) b;
         i = a->nvals;
      
         switch ( targtype ) {
	   case PDL_L:
             {
              PDL_Long *aa = (PDL_Long *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Long) *bb--;
             }
             break;

	   case PDL_F:
             {
              PDL_Float *aa = (PDL_Float *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Float) *bb--;
             }
             break;

	   case PDL_S:
             {
              PDL_Short *aa = (PDL_Short *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Short) *bb--;
             }
             break;

	   case PDL_D:
             {
              PDL_Double *aa = (PDL_Double *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Double) *bb--;
             }
             break;

	   case PDL_B:
             {
              PDL_Byte *aa = (PDL_Byte *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Byte) *bb--;
             }
             break;

	   case PDL_LL:
             {
              PDL_LongLong *aa = (PDL_LongLong *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_LongLong) *bb--;
             }
             break;

           default:
             croak("Don't know how to convert datatype PDL_US to #%d", targtype);
         } /* switch targtype */
         break;
        } /* case: PDL_US */

      case PDL_D:
        {
         PDL_Double *bb = (PDL_Double *) b;
         i = a->nvals;
      
         switch ( targtype ) {
	   case PDL_L:
             {
              PDL_Long *aa = (PDL_Long *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Long) *bb--;
             }
             break;

	   case PDL_F:
             {
              PDL_Float *aa = (PDL_Float *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Float) *bb--;
             }
             break;

	   case PDL_S:
             {
              PDL_Short *aa = (PDL_Short *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Short) *bb--;
             }
             break;

	   case PDL_US:
             {
              PDL_Ushort *aa = (PDL_Ushort *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Ushort) *bb--;
             }
             break;

	   case PDL_B:
             {
              PDL_Byte *aa = (PDL_Byte *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Byte) *bb--;
             }
             break;

	   case PDL_LL:
             {
              PDL_LongLong *aa = (PDL_LongLong *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_LongLong) *bb--;
             }
             break;

           default:
             croak("Don't know how to convert datatype PDL_D to #%d", targtype);
         } /* switch targtype */
         break;
        } /* case: PDL_D */

      case PDL_B:
        {
         PDL_Byte *bb = (PDL_Byte *) b;
         i = a->nvals;
      
         switch ( targtype ) {
	   case PDL_L:
             {
              PDL_Long *aa = (PDL_Long *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Long) *bb--;
             }
             break;

	   case PDL_F:
             {
              PDL_Float *aa = (PDL_Float *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Float) *bb--;
             }
             break;

	   case PDL_S:
             {
              PDL_Short *aa = (PDL_Short *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Short) *bb--;
             }
             break;

	   case PDL_US:
             {
              PDL_Ushort *aa = (PDL_Ushort *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Ushort) *bb--;
             }
             break;

	   case PDL_D:
             {
              PDL_Double *aa = (PDL_Double *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Double) *bb--;
             }
             break;

	   case PDL_LL:
             {
              PDL_LongLong *aa = (PDL_LongLong *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_LongLong) *bb--;
             }
             break;

           default:
             croak("Don't know how to convert datatype PDL_B to #%d", targtype);
         } /* switch targtype */
         break;
        } /* case: PDL_B */

      case PDL_LL:
        {
         PDL_LongLong *bb = (PDL_LongLong *) b;
         i = a->nvals;
      
         switch ( targtype ) {
	   case PDL_L:
             {
              PDL_Long *aa = (PDL_Long *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Long) *bb--;
             }
             break;

	   case PDL_F:
             {
              PDL_Float *aa = (PDL_Float *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Float) *bb--;
             }
             break;

	   case PDL_S:
             {
              PDL_Short *aa = (PDL_Short *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Short) *bb--;
             }
             break;

	   case PDL_US:
             {
              PDL_Ushort *aa = (PDL_Ushort *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Ushort) *bb--;
             }
             break;

	   case PDL_D:
             {
              PDL_Double *aa = (PDL_Double *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Double) *bb--;
             }
             break;

	   case PDL_B:
             {
              PDL_Byte *aa = (PDL_Byte *) a->data;
              aa += i-1; bb += i-1;
              while (i--)
                *aa-- = (PDL_Byte) *bb--;
             }
             break;

           default:
             croak("Don't know how to convert datatype PDL_LL to #%d", targtype);
         } /* switch targtype */
         break;
        } /* case: PDL_LL */

    default:
      croak("Don't know how to convert datatype %d to %d", intype, targtype);
    }

    if (changePerl) {   /* Tidy up */

      /* Store new data */

      if (diffsize) {
        STRLEN n_a;
         bar = a->datasv;
         sv_setpvn( bar, (char*) a->data, nbytes );
         a->data = (void*) SvPV(bar, n_a);
      }

    }

    a->datatype = targtype;
}


/* Ensure 'a' and 'b' are the same data types of high enough precision,
   using a reasonable set of rules.
*/

void pdl_coercetypes( pdl** aa, pdl** bb, Logical changePerl ) {

     pdl* a = *aa;  /* Double ptr passed as value of ptr may be changed to */
     pdl* b = *bb;  /* point at a temporary copy of the cached pdl */
     Logical oneisscalar;
     pdl *scalar,*vector;
     int targtype;

     if (a->datatype == b->datatype) /* Nothing to be done */
        return;

     /* Detect the vector & scalar case */

     oneisscalar = (a->nvals==1 || b->nvals==1) && !(a->nvals==1 && b->nvals==1);

     /* Rules for deciding what the target data type is */

     if (oneisscalar) {  /* Vector x Scalar case */

        scalar  = a; vector = b;
        if (b->nvals==1) {
           scalar = b;
           vector = a;
        }

        if (vector->datatype >= scalar->datatype) /* Vector more complex - easy */

           targtype = vector->datatype;

        else { /* Scalar more complex than vector- special rules to avoid
                  overzealous promotion of vector  */

           if (vector->datatype == PDL_F)  /* FxD is OK as F */
              targtype = vector->datatype;

           else if (vector->datatype <= PDL_L && scalar->datatype <= PDL_L)
              targtype = vector->datatype; /* two ints is OK as input int */

           else if (vector->datatype <= PDL_F && scalar->datatype==PDL_D)
              targtype = PDL_F; /* Only promote FOOxD as far as F */

           else
              targtype = scalar->datatype;

        }


     }else{ /* Vector x Vector - easy */

        targtype = a->datatype;
        if (b->datatype > a->datatype)
           targtype = b->datatype;

     }

     /* Do the conversion */

     pdl_converttype(aa, targtype, changePerl);
     pdl_converttype(bb, targtype, changePerl);
}

/* Given PDL return an allocated **ptr to 2D data thus allowing a[j][i] syntax */

void ** pdl_twod( pdl* x ) {

   int i,nx,ny,size;
   long *p;
   char *xx;

   if (x->ndims>2)
      croak("Data must be 1 or 2-dimensional for this routine");

   xx = (char*) x->data;

   nx = *(x->dims); ny = x->ndims==2 ? *(x->dims+1) : 1;

   size=pdl_howbig(x->datatype);

   p = (long*) pdl_malloc( ny*sizeof(long) ); /* 1D array of ptrs p[i] */
   for (i=0;i<ny;i++)
       p[i] = (long) &xx[i*nx*size];

   return (void**) p;
}

