/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.16 from the
 * contents of Transform.xs. Do not edit this file, edit Transform.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Transform.xs"

/*
 * THIS FILE WAS GENERATED BY PDL::PP! Do not modify!
 */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "pdl.h"
#include "pdlcore.h"
static Core* PDL; /* Structure hold core C functions */
static int __pdl_debugging = 0;
static int __pdl_boundscheck = 0;
static SV* CoreSV;       /* Gets pointer to perl var holding core structure */

#if ! 1
# define PP_INDTERM(max, at) at
#else
# define PP_INDTERM(max, at) (__pdl_boundscheck? PDL->safe_indterm(max,at, __FILE__, __LINE__) : at)
#endif



/* 
 * Singular-value decomposition code is borrowed from 
 * MatrixOps -- cut-and-pasted here because of linker trouble.
 * It's used by the auxiliary matrix manipulation code, below.
 *
 */

void pdl_xform_svd(PDL_Double *W, PDL_Double *Z, int nRow, int nCol)
{
  int i, j, k, EstColRank, RotCount, SweepCount, slimit;
  PDL_Double eps, e2, tol, vt, p, h2, x0, y0, q, r, c0, s0, c2, d1, d2;
  eps = 1e-6;
  slimit = nCol/4;
  if (slimit < 6.0)
    slimit = 6;
  SweepCount = 0;
  e2 = 10.0*nRow*eps*eps;
  tol = eps*.1;
  EstColRank = nCol;
  for (i=0; i<nCol; i++) {
    for (j=0; j<nCol; j++) {
      W[nCol*(nRow+i)+j] = 0.0;
    }
    W[nCol*(nRow+i)+i] = 1.0;  /* rjrw 7/7/99: moved this line out of j loop */
  }
  RotCount = EstColRank*(EstColRank-1)/2;
  while (RotCount != 0 && SweepCount <= slimit)
    {
      RotCount = EstColRank*(EstColRank-1)/2;
      SweepCount++;
      for (j=0; j<EstColRank-1; j++)
        {
          for (k=j+1; k<EstColRank; k++)
            {
              p = q = r = 0.0;
              for (i=0; i<nRow; i++)
                {
                  x0 = W[nCol*i+j]; y0 = W[nCol*i+k];
                  p += x0*y0; q += x0*x0; r += y0*y0;
                }
              Z[j] = q; Z[k] = r;
              if (q >= r)
                {
                  if (q<=e2*Z[0] || fabs(p)<=tol*q) RotCount--;
                  else
                    {
                      p /= q; r = 1 - r/q; vt = sqrt(4*p*p+r*r);
                      c0 = sqrt(fabs(.5*(1+r/vt))); s0 = p/(vt*c0);
                      for (i=0; i<nRow+nCol; i++)
                        {
                          d1 = W[nCol*i+j]; d2 = W[nCol*i+k];
                          W[nCol*i+j] = d1*c0+d2*s0; W[nCol*i+k] = -d1*s0+d2*c0;
                        }
                    }
                }
              else
                {
                  p /= r; q = q/r-1; vt = sqrt(4*p*p+q*q);
                  s0 = sqrt(fabs(.5*(1-q/vt)));
                  if (p<0) s0 = -s0;
                  c0 = p/(vt*s0);
                  for (i=0; i<nRow+nCol; i++)
                    {
                      d1 = W[nCol*i+j]; d2 = W[nCol*i+k];
                      W[nCol*i+j] = d1*c0+d2*s0; W[nCol*i+k] = -d1*s0+d2*c0;
                    }
                }
            }
        }
      while (EstColRank>=3 && Z[(EstColRank-1)]<=Z[0]*tol+tol*tol)
        EstColRank--;
    }
}


/* 
 * PDL_xform_aux: 
 *  This handles the matrix manipulation part of the Jacobian filtered
 *  mapping code.  It's separate from the main code because it's 
 *  independent of the data type of the original arrays.
 *
 *Given a pre-allocated workspace  and 
 * an integer set of coordinates, generate the discrete Jacobian 
 * from the map, pad the singular values, and return the inverse
 * Jacobian, the largest singular value of the Jacobian itself, and
 * the determinant of the original Jacobian.  Boundary values use the 
 * asymmetric discrete Jacobian; others use the symmetric discrete Jacobian.
 *
 * The map and workspace must be of type PDL_D.  If the dimensionality is 
 * d, then the workspace must have at least 3*n^2+n elements.  The 
 * inverse of the padded Jacobian is returned in the first n^2 elements.
 * The determinant of the original Jacobian gets stuffed into the n^2 
 * element of the workspace. The largest padded singular value is returned.  
 *
 */

PDL_Double PDL_xform_aux ( pdl *map, PDL_Long *coords, PDL_Double *tmp, PDL_Double sv_min) {
  short ndims;
  PDL_Long i, j, k;
  PDL_Long offset;
  PDL_Double det;
  PDL_Double *jptr;
  PDL_Double *svptr;
  PDL_Double *aptr,*bptr;
  PDL_Double max_sv = 0.0;

  ndims = map->ndims-1;
	
  /****** Accumulate the Jacobian */
  /* Accumulate the offset into the map array */
  for( i=offset=0; i<ndims; i++) 
    offset += coords[i] * map->dimincs[i+1];

  jptr = tmp + ndims*ndims;

  for( i=0; i<ndims; i++) {                    /* Loop over offset direction */
    char bot = (coords[i] <=0);
    char top = (coords[i] >= map->dims[i+1]-1);
    char symmetric = !(bot || top);
    PDL_Double *ohi,*olo;
    PDL_Long diff = map->dimincs[i+1];
    ohi = ((PDL_Double *)map->data) + ( offset + ( top ? 0 : diff ));
    olo = ((PDL_Double *)map->data) + ( offset - ( bot ? 0 : diff ));
    
    for( j=0; j<ndims; j++) {                 /* Loop over dimension */
       PDL_Double jel =   *ohi - *olo;

       ohi += map->dimincs[0];
       olo += map->dimincs[0];

       if(symmetric)      
         jel /= 2;
       *(jptr++) = jel;
    }
  }

  /****** Singular-value decompose the Jacobian 
   * The svd routine produces the squares of the singular values,
   * and requires normalization for one of the rotation matrices. 
   */

  jptr =   tmp + ndims*ndims;
  svptr = tmp + 3*ndims*ndims;
  pdl_xform_svd(jptr,svptr,ndims,ndims);

  aptr = svptr;
  for (i=0;i<ndims;i++,aptr++)
    *aptr = sqrt(*aptr);


  /* fix-up matrices here */
  bptr = jptr;
  for(i=0; i<ndims;i++) {
    aptr = svptr;
    for(j=0;j<ndims;j++)
     *(bptr++) /= *(aptr++);
  }

  /****** Store the determinant, and pad the singular values as necessary.*/
  aptr = svptr;
  det = 1.0;
  for(i=0;i<ndims;i++) {
    det *= *aptr;
    if(*aptr < sv_min)
      *aptr = sv_min;
    if(*aptr > max_sv )
	max_sv = *aptr;
    aptr++;
  }
 
  /****** Generate the inverse matrix */
  /* Multiply B-transpose times 1/S times A-transpose. */
  /* since S is diagonal we just divide by the appropriate element. */
  /* */
  aptr = tmp  + ndims*ndims;
  bptr = aptr + ndims*ndims;
  jptr=  tmp;

  for(i=0;i<ndims;i++) {
    for(j=0;j<ndims;j++) {
	*jptr = 0;

	for(k=0;k<ndims;k++) 
	  *jptr += aptr[j*ndims + k] * bptr[k*ndims + i] / *svptr; 

	jptr++;
    }
    svptr++;
  }

 *jptr = det; 
  return max_sv;
}

typedef struct pdl_map_struct {
		PDL_TRANS_START(1);
		pdl_thread  __pdlthread;
		SV  *in;SV  *out;SV  *map;SV  *boundary;SV  *method;SV  *big;SV  *blur;SV  *sv_min;SV  *flux;
		char __ddone; /* Dims done */
		} pdl_map_struct;

void pdl_map_redodims(pdl_trans *__tr ) {
	int __dim;
	pdl_map_struct *__privtrans = (pdl_map_struct *) __tr;
	
	{
	    int __creating[1];
__creating[0] = 0;
 {
/* no RedoDimsCode */
}
 {
 static char *__parnames[] = {"k0"};
		static int __realdims[] = {0};
		static char __funcname[] = "PDL::Transform::map";
		static pdl_errorinfo __einfo = {
			__funcname, __parnames, 1
		};
		
		 PDL->initthreadstruct(2,__privtrans->pdls,
			__realdims,__creating,1,
                      &__einfo,&(__privtrans->__pdlthread),
                        __privtrans->vtable->per_pdl_flags, 
			0 );
		}

{ /* convenience block */
  void *hdrp = NULL;
  char propagate_hdrcpy = 0;
  SV *hdr_copy = NULL;
      if(!hdrp && 
	      __privtrans->pdls[0]->hdrsv && 
	 (__privtrans->pdls[0]->state & PDL_HDRCPY) 
	 ) {
	hdrp = __privtrans->pdls[0]->hdrsv;
	propagate_hdrcpy = ((__privtrans->pdls[0]->state & PDL_HDRCPY) != 0);
      }
if (hdrp) {
  if(hdrp == &PL_sv_undef) 
    hdr_copy = &PL_sv_undef;
  else  {  /* Call the perl routine _hdr_copy... */
    int count;
    /* Call the perl routine PDL::_hdr_copy(hdrp) */
    dSP;
    ENTER ;
    SAVETMPS ;
    PUSHMARK(SP) ;
    XPUSHs( hdrp );
    PUTBACK ;
    count = call_pv("PDL::_hdr_copy",G_SCALAR);
    SPAGAIN ;
    if(count != 1) 
	croak("PDL::_hdr_copy didn't return a single value - please report this bug (A).");
    
    hdr_copy = (SV *)POPs;

    if(hdr_copy && hdr_copy != &PL_sv_undef)
       SvREFCNT_inc(hdr_copy); /*Keep hdr_copy from vanishing during FREETMPS*/

    FREETMPS ;
    LEAVE ;


  } /* end of callback  block */

    if(hdr_copy != &PL_sv_undef) 
      SvREFCNT_dec(hdr_copy); /* make hdr_copy mortal again */
   } /* end of if(hdrp) block */
} /* end of conv. block */
 __privtrans->__ddone = 1;
	}
    }
    

pdl_trans * pdl_map_copy(pdl_trans *__tr ) {
	int __dim;
	pdl_map_struct *__privtrans = (pdl_map_struct *) __tr;
	
	{
	    pdl_map_struct *__copy = malloc(sizeof(pdl_map_struct));
PDL_THR_CLRMAGIC(&__copy->__pdlthread);			PDL_TR_CLRMAGIC(__copy);
                        __copy->has_badvalue = __privtrans->has_badvalue;
                        __copy->badvalue = __privtrans->badvalue;
			__copy->flags = __privtrans->flags;
			__copy->vtable = __privtrans->vtable;
			__copy->__datatype = __privtrans->__datatype;
			__copy->freeproc = NULL;
			__copy->__ddone = __privtrans->__ddone;
			{int i;
			 for(i=0; i<__copy->vtable->npdls; i++)
				__copy->pdls[i] = __privtrans->pdls[i];
			}
			(__copy->in) = newSVsv(__privtrans->in);;(__copy->out) = newSVsv(__privtrans->out);;(__copy->map) = newSVsv(__privtrans->map);;(__copy->boundary) = newSVsv(__privtrans->boundary);;(__copy->method) = newSVsv(__privtrans->method);;(__copy->big) = newSVsv(__privtrans->big);;(__copy->blur) = newSVsv(__privtrans->blur);;(__copy->sv_min) = newSVsv(__privtrans->sv_min);;(__copy->flux) = newSVsv(__privtrans->flux);;
			if(__copy->__ddone) {
				PDL->thread_copy(&(__privtrans->__pdlthread),&(__copy->__pdlthread));
			}
			return (pdl_trans*)__copy;
	}
    }
    

void pdl_map_readdata(pdl_trans *__tr ) {
	int __dim;
	pdl_map_struct *__privtrans = (pdl_map_struct *) __tr;
	
	{
	    {/* Start generic loop */

	switch(__privtrans->__datatype) { case -42: /* Warning eater */ {1;
	} break; case PDL_B: {
	PDL_Byte * k0_datap = ((PDL_Byte *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Byte * k0_physdatap = ((PDL_Byte *)((__privtrans->pdls[0])->data));

	/* THREADLOOPBEGIN */
 if(PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata,
 	__tr)) return;
   do { register int __tind1=0,__tind2=0;
        register int __tnpdls = __privtrans->__pdlthread.npdls;
      register int __tdims1 = __privtrans->__pdlthread.dims[1];
      register int __tdims0 = __privtrans->__pdlthread.dims[0];
      register int *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
 register int __tinc0_0 = __privtrans->__pdlthread.incs[0];register int __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];k0_datap += __offsp[0];

	for(__tind2=0; __tind2<__tdims1 ; __tind2++) {
	 for(__tind1=0; __tind1<__tdims0 ; __tind1++) {
	  /* This is the tightest threadloop. Make sure inside is optimal. */
{
/*
 * Pixel interpolation & averaging code
 * 
 * Calls a common coordinate-transformation block (see following hdr)
 * that isn't dependent on the type of the input variable.
 *
 * The inputs are SVs to avoid hassling with threadloops; threading 
 * is handled internally.  To simplify the threading business, any 
 * thread dimensions should all be collapsed to a single one by the
 * perl front-end.
 *
 */

 short ndims;           /* Number of dimensions we're working in    */
 PDL_Double *tmp;           /* Workspace for prefrobnication            */
 PDL_Long  *ovec;           /* output pixel loop vector                 */
 PDL_Long  *ivec;           /* input pixel loop vector                  */
 PDL_Long  *ibvec;          /* input pixel base offset vector           */
 PDL_Double *dvec;          /* Residual vector for linearization        */
 PDL_Double *tvec;          /* Temporary floating-point vector          */
 PDL_Double *acc;           /* Threaded accumulator                     */
 char   *bounds;        /* Boundary condition packed string         */
 char   method;         /* Method identifier (gets one of 'h','g')  */
 PDL_Long   big;            /* Max size of input footprint for each pix */
 PDL_Double blur;           /* Scaling of filter                        */
 PDL_Double sv_min;         /* minimum singular value                   */
 char flux;             /* Flag to indicate flux conservation       */
 PDL_Double *map_ptr;
 PDL_Long i, j;
 PDL_Byte badval = sqrt(-1);

 pdl *in  = PDL->SvPDLV(__privtrans->in);
 pdl *out = PDL->SvPDLV(__privtrans->out);
 pdl *map = PDL->SvPDLV(__privtrans->map);

 PDL->make_physical(in);
 PDL->make_physical(out);
 PDL->make_physical(map);

 ndims = map->ndims -1;

  /***************************************************************************/
  /**  Check that the dimensionalities are consistent.  This is             **/
  /**  allegedly done already in the perl part, but shouldn't cost more     **/
  /**  than a few hundred clock cycles -- cheap at twice the price.         **/
  /**                                                                       **/
  /**/ if(map->ndims != out->ndims)                                        /**/
  /**/  barf("%s", "Bug in map: index dims aren't consistent\n");          /**/
  /**/ for(i=0;i<out->ndims-1;i++) {                                       /**/
  /**/   static char buf[100];                                             /**/
  /**/   if(map->dims[i+1] != out->dims[i]) {                              /**/
  /**/     sprintf(buf,"Bug in map: dim %d is %d; expected %d\n",          /**/
  /**/                 i,map->dims[i+1],out->dims[i]);                     /**/
  /**/     barf("%s", buf);                                                /**/
  /**/   }                                                                 /**/
  /**/ }                                                                   /**/
  /**/ if(map->dims[0] != in->ndims - 1)                                   /**/
  /**/   barf("%s", "Bug in map - index vec - input mismatch\n");          /**/
  /**/ if(out->dims[out->ndims-1] != in->dims[in->ndims-1])                /**/
  /**/   barf("%s", "Bug in map:  thread dimension error\n");              /**/
  /***************************************************************************/

 /* 
  * Allocate all our dynamic workspaces at once...
 /* */
 ovec = (PDL_Long *)(PDL->smalloc( (STRLEN)
	          	      ( sizeof(PDL_Long)   * 3 * ndims
                              + sizeof(PDL_Double) * (3*ndims*ndims + 3*ndims)
                              + sizeof(PDL_Double) * in->dims[ndims] 
                              + sizeof(char) * ndims )
		             )
		);
 ivec =            &(ovec[ndims]); 
 ibvec =           &(ivec[ndims]);
 dvec = (PDL_Double *)(&(ibvec[ndims]));
 tvec =            &(dvec[ndims]);
 acc  =            &(tvec[ndims]);
 tmp  =            &(acc[in->dims[ndims]]);
 bounds = (char *)(&(tmp [3*ndims*ndims+ndims]));


/***
 * Fill in the boundary condition array
 * (cut-and-pasted from the range() code...)
 */
 {
  char *bstr;
  STRLEN blen;
  bstr = SvPV(__privtrans->boundary,blen);

  if(blen == 0) {
    /* If no boundary is specified then every dim gets truncated */
    int i;
    for (i=0;i<ndims;i++) 
      bounds[i] = 1;
  } else {
    int i;
    for(i=0;i<ndims;i++) {
      switch(bstr[i < blen ? i : blen-1 ]) {
      case '0': case 'f': case 'F':               /* forbid */
	bounds[i] = 0;
	break;
      case '1': case 't': case 'T':               /* truncate */
	bounds[i] = 1;
	break;
      case '2': case 'e': case 'E':               /* extend */
	bounds[i] = 2;
	break;
      case '3': case 'p': case 'P':               /* periodic */
	bounds[i] = 3;
	break;
      case '4': case 'm': case 'M':               /* mirror */
	bounds[i] = 4;
	break;
      default:
	{
	  char buf[BUFSIZ];
	  sprintf(buf,"Error in map: Unknown boundary condition '%c'",bstr[i]);
	  barf("%s", buf);
	}
	break;
      }
    }
  }
 }  

/***
 * Parse out the 'method', 'big', 'blur', and 'sv_min' arguments
 */
 {
  char *mstr;
  STRLEN mlen;
  mstr = SvPV(__privtrans->method,mlen);

  if(mlen==0) 
	method = 'h';
  else switch(*mstr) {
	case 'h': case 'H': 
		method = 'h'; break;
        case 'g': case 'G': 
	case 'j': case 'J': 
		method = 'g'; break;
        default: 
	   {
            char err[80];
            sprintf(err,"Bug in map: unknown method '%c'",*mstr);
	    barf("%s", err);
           }
           break;
	}
 }
 big    = labs((PDL_Long)   (SvNV(__privtrans->big))); 
 blur   = fabs((PDL_Double) (SvNV(__privtrans->blur)));
 sv_min = fabs((PDL_Double) (SvNV(__privtrans->sv_min)));
 flux   = (SvNV(__privtrans->flux) != 0);

 /* End of initialization */
 /*************************************************************/
 /* Start of Real Work */
 	
 /* Initialize coordinate vector and map offset
  */
 for(i=0;i<ndims;i++)
	ovec[i] = 0;
 map_ptr = (PDL_Double *)(map->data);

 /* Main pixel loop */
 do {
   PDL_Long psize;
   PDL_Double wgt;

   /* Prefrobnicate the transformation matrix  */
   psize = (PDL_Long)(blur * PDL_xform_aux(map, ovec, tmp, sv_min) + 0.5 )+1;
   if(psize <= big) {
     /* 
      * Use the prefrobnicated matrix to generate a local linearization 
      * dvec gets the delta; ibvec gets the base. 
      */
     {
       PDL_Double *mp = map_ptr;
       for (i=0;i<ndims;i++) {
  	dvec[i]  = *mp - ( ibvec[i] = (PDL_Long)(*mp + 0.5));   /* assignment */
  	mp += map->dimincs[0];
       }
     }
  
     /* 
      * Initialize input delta vector
      */
     for(i=0;i<ndims;i++)
  	ivec[i] = - psize;
  
     /* 
      * Initialize accumulators
      */
     {
       PDL_Double *ac = acc;
       for(i=0; i < in->dims[ndims]; i++)
  	*(ac++) = 0.0;
     }
     wgt = 1.0e-9;  /* negligible but nonzero */
    
     do {  /* Input accumulation loop */
       int bound_ok = 1;
       PDL_Long i_off = 0;
  
       /* Find the offset for the current input point, applying boundaries */
  
       for(i=0; i<ndims && bound_ok; i++) {
         j = ivec[i] + ibvec[i];
         if(j < 0 || j >= in->dims[i]) {
           switch(bounds[i]) {
             case 0: /* no breakage allowed */
               barf("%s", "index out-of-bounds in map");
               break;
             case 1: /* truncation */
               bound_ok = 0;
               break;
             case 2: /* extension -- crop */
               if(j<0)
                 j = 0;
               else if(j>= in->dims[i])
                 j = in->dims[i] - 1;
               break;
             case 3: /* periodic -- mod it */
               j %= in->dims[i];
               if(j<0)
                 j += in->dims[i];
               break;
             case 4: /* mirror -- reflect off the edges */
               j += in->dims[i];
               j %= (in->dims[i] * 2);
               if(j < 0) 
                 j += in->dims[i] * 2;
               j -= in->dims[i];
               if(j < 0) {
                 j *= -1;
                 j -= 1;
               }
               break;
             default:
               barf("%s", "Unknown boundary condition in map -- bug alert!");
               break;
           }
         }
         i_off += in->dimincs[i] * j;
       }
  
       {  /* convenience block for bounds handling and data weighting */
         PDL_Double alpha = 1.0;
         PDL_Double *ap = tvec;
         PDL_Double *bp = dvec;
         PDL_Double *cp;
         PDL_Long *ip   = ivec;
  
         for(i=0; i<ndims; i++)
           *(ap++) = *(ip++) - *(bp++);
       
       /* Calculate the linearization-transformed point, and 
        * infer a weighting from it.  Use the per-dimension Hanning 
        * window or a radial Gaussian.
        */
         cp = tmp;
        
         switch(method) {
            PDL_Double dd;
  
  	case 'h':
  	       for(i=0; i<ndims; i++) {
  	         dd = 0;
  	         ap = tvec;
  	         for(j=0;j<ndims; j++)
  	             dd += *(ap++) * *(cp++);
  	         dd = fabs(dd) / blur;
  	         if( dd > 1 ) {
  	             alpha = 0;
  	             i = ndims;
  	         } else 
  	             alpha *= (0.5 + 0.5 * cos( dd * 3.1415926536 ));            
  	       }
   	      break;
  	case 'g':
                {PDL_Double sum = 0;
  
  	       for(i=0; i<ndims; i++) {
  	         dd = 0;
  	         ap = tvec;
  	          for(j=0;j<ndims; j++)
  	             dd += *(ap++) * *(cp++);
  	          dd /= blur;
  	 	  sum += dd * dd;
  		  if(sum > 4) /* 2 pixels -- four half-widths */
  		    i = ndims; /* exit early if this pixel is too far outside the footprint of the ideal point */
  	       }
  	       
   	       if(sum > 4)	
  		  alpha = 0;
  	       else
  		  alpha = exp(-sum * 1.386294); /* Gaussian, rt(2)-pix HWHM */
  	     }
   	      break;
  	 default: 
  	     {
                 char buf[80];
                  sprintf(buf,"This can't happen: method='%c'",method);
  	        barf("%s", buf);
  	     }
  	}
  
  
        /* We've got the weighting, now accumulate the values as needed... */
         wgt += alpha;
       
       if(bound_ok)
         { 
          PDL_Double *ac = acc;
          PDL_Byte *dat = ((PDL_Byte *)(in->data)) + i_off;
          for( i=0; i < out->dims[ndims]; i++ ) {
               *(ac++) += *dat * alpha;
               dat += in->dimincs[ndims];
          }
         }/* end of bound_ok check */

       }  /* end of data collection convenience block */
       
       /* Advance input accumulation loop */
       for(i=0; 
             (i < ndims) &&
             (++(ivec[i]) > psize);
           i++) {
          ivec[i] = -psize;
       }
     } while(i<ndims);  /* end of total data accumulation loop */
     
     {
       PDL_Double *ac = acc;
       PDL_Byte *dat = out->data;
       
       for(i=0;i<ndims;i++) 
         dat += out->dimincs[i] * ovec[i];

       if(flux) {       
	  PDL_Double det = tmp[ndims*ndims];
          for(i=0; i < out->dims[ndims]; i++) {
            *dat = *(ac++) / wgt * det;
            dat += out->dimincs[ndims];
	  }
       } else {
	  for(i=0; i < out->dims[ndims]; i++) {
           *dat = *(ac++) / wgt;
           dat += out->dimincs[ndims];
          }
       }
     }

     /* End of code for normal pixels */
   } else {       
     /* The pixel was ludicrously huge -- just set this pixel to nan */
     PDL_Byte *dat = out->data;
      for(i=0;i<ndims;i++)
	dat += out->dimincs[i] * ovec[i];
      for(i=0;i<out->dims[ndims];i++) {
	*dat = badval;          /* Should handle bad values too -- not yet */
        dat += out->dimincs[ndims];
      }
   }

   /* Increment the pixel counter */
   {
     PDL_Long *aptr = ovec;
     for(i=0;
	     (i<ndims) &&
             (map_ptr += map->dimincs[i+1]) &&  /* Funky pre-test increment */
 	     (++(ovec[i]) >= out->dims[i]);     /* Actual carry test */
	 i++) {
	ovec[i] = 0;
	map_ptr -= out->dims[i] * map->dimincs[i+1];
     }
    }
  } while(i<ndims);



}	/* THREADLOOPEND */
	 k0_datap += __tinc0_0;

	 } k0_datap += __tinc1_0
	     			     - __tinc0_0 *
				       __tdims0;

	} k0_datap -= __tinc1_0 *
     				  __tdims1;
 k0_datap -= __offsp[0];

      } while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));
 	} break; case PDL_S: {
	PDL_Short * k0_datap = ((PDL_Short *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Short * k0_physdatap = ((PDL_Short *)((__privtrans->pdls[0])->data));

	/* THREADLOOPBEGIN */
 if(PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata,
 	__tr)) return;
   do { register int __tind1=0,__tind2=0;
        register int __tnpdls = __privtrans->__pdlthread.npdls;
      register int __tdims1 = __privtrans->__pdlthread.dims[1];
      register int __tdims0 = __privtrans->__pdlthread.dims[0];
      register int *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
 register int __tinc0_0 = __privtrans->__pdlthread.incs[0];register int __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];k0_datap += __offsp[0];

	for(__tind2=0; __tind2<__tdims1 ; __tind2++) {
	 for(__tind1=0; __tind1<__tdims0 ; __tind1++) {
	  /* This is the tightest threadloop. Make sure inside is optimal. */
{
/*
 * Pixel interpolation & averaging code
 * 
 * Calls a common coordinate-transformation block (see following hdr)
 * that isn't dependent on the type of the input variable.
 *
 * The inputs are SVs to avoid hassling with threadloops; threading 
 * is handled internally.  To simplify the threading business, any 
 * thread dimensions should all be collapsed to a single one by the
 * perl front-end.
 *
 */

 short ndims;           /* Number of dimensions we're working in    */
 PDL_Double *tmp;           /* Workspace for prefrobnication            */
 PDL_Long  *ovec;           /* output pixel loop vector                 */
 PDL_Long  *ivec;           /* input pixel loop vector                  */
 PDL_Long  *ibvec;          /* input pixel base offset vector           */
 PDL_Double *dvec;          /* Residual vector for linearization        */
 PDL_Double *tvec;          /* Temporary floating-point vector          */
 PDL_Double *acc;           /* Threaded accumulator                     */
 char   *bounds;        /* Boundary condition packed string         */
 char   method;         /* Method identifier (gets one of 'h','g')  */
 PDL_Long   big;            /* Max size of input footprint for each pix */
 PDL_Double blur;           /* Scaling of filter                        */
 PDL_Double sv_min;         /* minimum singular value                   */
 char flux;             /* Flag to indicate flux conservation       */
 PDL_Double *map_ptr;
 PDL_Long i, j;
 PDL_Short badval = sqrt(-1);

 pdl *in  = PDL->SvPDLV(__privtrans->in);
 pdl *out = PDL->SvPDLV(__privtrans->out);
 pdl *map = PDL->SvPDLV(__privtrans->map);

 PDL->make_physical(in);
 PDL->make_physical(out);
 PDL->make_physical(map);

 ndims = map->ndims -1;

  /***************************************************************************/
  /**  Check that the dimensionalities are consistent.  This is             **/
  /**  allegedly done already in the perl part, but shouldn't cost more     **/
  /**  than a few hundred clock cycles -- cheap at twice the price.         **/
  /**                                                                       **/
  /**/ if(map->ndims != out->ndims)                                        /**/
  /**/  barf("%s", "Bug in map: index dims aren't consistent\n");          /**/
  /**/ for(i=0;i<out->ndims-1;i++) {                                       /**/
  /**/   static char buf[100];                                             /**/
  /**/   if(map->dims[i+1] != out->dims[i]) {                              /**/
  /**/     sprintf(buf,"Bug in map: dim %d is %d; expected %d\n",          /**/
  /**/                 i,map->dims[i+1],out->dims[i]);                     /**/
  /**/     barf("%s", buf);                                                /**/
  /**/   }                                                                 /**/
  /**/ }                                                                   /**/
  /**/ if(map->dims[0] != in->ndims - 1)                                   /**/
  /**/   barf("%s", "Bug in map - index vec - input mismatch\n");          /**/
  /**/ if(out->dims[out->ndims-1] != in->dims[in->ndims-1])                /**/
  /**/   barf("%s", "Bug in map:  thread dimension error\n");              /**/
  /***************************************************************************/

 /* 
  * Allocate all our dynamic workspaces at once...
 /* */
 ovec = (PDL_Long *)(PDL->smalloc( (STRLEN)
	          	      ( sizeof(PDL_Long)   * 3 * ndims
                              + sizeof(PDL_Double) * (3*ndims*ndims + 3*ndims)
                              + sizeof(PDL_Double) * in->dims[ndims] 
                              + sizeof(char) * ndims )
		             )
		);
 ivec =            &(ovec[ndims]); 
 ibvec =           &(ivec[ndims]);
 dvec = (PDL_Double *)(&(ibvec[ndims]));
 tvec =            &(dvec[ndims]);
 acc  =            &(tvec[ndims]);
 tmp  =            &(acc[in->dims[ndims]]);
 bounds = (char *)(&(tmp [3*ndims*ndims+ndims]));


/***
 * Fill in the boundary condition array
 * (cut-and-pasted from the range() code...)
 */
 {
  char *bstr;
  STRLEN blen;
  bstr = SvPV(__privtrans->boundary,blen);

  if(blen == 0) {
    /* If no boundary is specified then every dim gets truncated */
    int i;
    for (i=0;i<ndims;i++) 
      bounds[i] = 1;
  } else {
    int i;
    for(i=0;i<ndims;i++) {
      switch(bstr[i < blen ? i : blen-1 ]) {
      case '0': case 'f': case 'F':               /* forbid */
	bounds[i] = 0;
	break;
      case '1': case 't': case 'T':               /* truncate */
	bounds[i] = 1;
	break;
      case '2': case 'e': case 'E':               /* extend */
	bounds[i] = 2;
	break;
      case '3': case 'p': case 'P':               /* periodic */
	bounds[i] = 3;
	break;
      case '4': case 'm': case 'M':               /* mirror */
	bounds[i] = 4;
	break;
      default:
	{
	  char buf[BUFSIZ];
	  sprintf(buf,"Error in map: Unknown boundary condition '%c'",bstr[i]);
	  barf("%s", buf);
	}
	break;
      }
    }
  }
 }  

/***
 * Parse out the 'method', 'big', 'blur', and 'sv_min' arguments
 */
 {
  char *mstr;
  STRLEN mlen;
  mstr = SvPV(__privtrans->method,mlen);

  if(mlen==0) 
	method = 'h';
  else switch(*mstr) {
	case 'h': case 'H': 
		method = 'h'; break;
        case 'g': case 'G': 
	case 'j': case 'J': 
		method = 'g'; break;
        default: 
	   {
            char err[80];
            sprintf(err,"Bug in map: unknown method '%c'",*mstr);
	    barf("%s", err);
           }
           break;
	}
 }
 big    = labs((PDL_Long)   (SvNV(__privtrans->big))); 
 blur   = fabs((PDL_Double) (SvNV(__privtrans->blur)));
 sv_min = fabs((PDL_Double) (SvNV(__privtrans->sv_min)));
 flux   = (SvNV(__privtrans->flux) != 0);

 /* End of initialization */
 /*************************************************************/
 /* Start of Real Work */
 	
 /* Initialize coordinate vector and map offset
  */
 for(i=0;i<ndims;i++)
	ovec[i] = 0;
 map_ptr = (PDL_Double *)(map->data);

 /* Main pixel loop */
 do {
   PDL_Long psize;
   PDL_Double wgt;

   /* Prefrobnicate the transformation matrix  */
   psize = (PDL_Long)(blur * PDL_xform_aux(map, ovec, tmp, sv_min) + 0.5 )+1;
   if(psize <= big) {
     /* 
      * Use the prefrobnicated matrix to generate a local linearization 
      * dvec gets the delta; ibvec gets the base. 
      */
     {
       PDL_Double *mp = map_ptr;
       for (i=0;i<ndims;i++) {
  	dvec[i]  = *mp - ( ibvec[i] = (PDL_Long)(*mp + 0.5));   /* assignment */
  	mp += map->dimincs[0];
       }
     }
  
     /* 
      * Initialize input delta vector
      */
     for(i=0;i<ndims;i++)
  	ivec[i] = - psize;
  
     /* 
      * Initialize accumulators
      */
     {
       PDL_Double *ac = acc;
       for(i=0; i < in->dims[ndims]; i++)
  	*(ac++) = 0.0;
     }
     wgt = 1.0e-9;  /* negligible but nonzero */
    
     do {  /* Input accumulation loop */
       int bound_ok = 1;
       PDL_Long i_off = 0;
  
       /* Find the offset for the current input point, applying boundaries */
  
       for(i=0; i<ndims && bound_ok; i++) {
         j = ivec[i] + ibvec[i];
         if(j < 0 || j >= in->dims[i]) {
           switch(bounds[i]) {
             case 0: /* no breakage allowed */
               barf("%s", "index out-of-bounds in map");
               break;
             case 1: /* truncation */
               bound_ok = 0;
               break;
             case 2: /* extension -- crop */
               if(j<0)
                 j = 0;
               else if(j>= in->dims[i])
                 j = in->dims[i] - 1;
               break;
             case 3: /* periodic -- mod it */
               j %= in->dims[i];
               if(j<0)
                 j += in->dims[i];
               break;
             case 4: /* mirror -- reflect off the edges */
               j += in->dims[i];
               j %= (in->dims[i] * 2);
               if(j < 0) 
                 j += in->dims[i] * 2;
               j -= in->dims[i];
               if(j < 0) {
                 j *= -1;
                 j -= 1;
               }
               break;
             default:
               barf("%s", "Unknown boundary condition in map -- bug alert!");
               break;
           }
         }
         i_off += in->dimincs[i] * j;
       }
  
       {  /* convenience block for bounds handling and data weighting */
         PDL_Double alpha = 1.0;
         PDL_Double *ap = tvec;
         PDL_Double *bp = dvec;
         PDL_Double *cp;
         PDL_Long *ip   = ivec;
  
         for(i=0; i<ndims; i++)
           *(ap++) = *(ip++) - *(bp++);
       
       /* Calculate the linearization-transformed point, and 
        * infer a weighting from it.  Use the per-dimension Hanning 
        * window or a radial Gaussian.
        */
         cp = tmp;
        
         switch(method) {
            PDL_Double dd;
  
  	case 'h':
  	       for(i=0; i<ndims; i++) {
  	         dd = 0;
  	         ap = tvec;
  	         for(j=0;j<ndims; j++)
  	             dd += *(ap++) * *(cp++);
  	         dd = fabs(dd) / blur;
  	         if( dd > 1 ) {
  	             alpha = 0;
  	             i = ndims;
  	         } else 
  	             alpha *= (0.5 + 0.5 * cos( dd * 3.1415926536 ));            
  	       }
   	      break;
  	case 'g':
                {PDL_Double sum = 0;
  
  	       for(i=0; i<ndims; i++) {
  	         dd = 0;
  	         ap = tvec;
  	          for(j=0;j<ndims; j++)
  	             dd += *(ap++) * *(cp++);
  	          dd /= blur;
  	 	  sum += dd * dd;
  		  if(sum > 4) /* 2 pixels -- four half-widths */
  		    i = ndims; /* exit early if this pixel is too far outside the footprint of the ideal point */
  	       }
  	       
   	       if(sum > 4)	
  		  alpha = 0;
  	       else
  		  alpha = exp(-sum * 1.386294); /* Gaussian, rt(2)-pix HWHM */
  	     }
   	      break;
  	 default: 
  	     {
                 char buf[80];
                  sprintf(buf,"This can't happen: method='%c'",method);
  	        barf("%s", buf);
  	     }
  	}
  
  
        /* We've got the weighting, now accumulate the values as needed... */
         wgt += alpha;
       
       if(bound_ok)
         { 
          PDL_Double *ac = acc;
          PDL_Short *dat = ((PDL_Short *)(in->data)) + i_off;
          for( i=0; i < out->dims[ndims]; i++ ) {
               *(ac++) += *dat * alpha;
               dat += in->dimincs[ndims];
          }
         }/* end of bound_ok check */

       }  /* end of data collection convenience block */
       
       /* Advance input accumulation loop */
       for(i=0; 
             (i < ndims) &&
             (++(ivec[i]) > psize);
           i++) {
          ivec[i] = -psize;
       }
     } while(i<ndims);  /* end of total data accumulation loop */
     
     {
       PDL_Double *ac = acc;
       PDL_Short *dat = out->data;
       
       for(i=0;i<ndims;i++) 
         dat += out->dimincs[i] * ovec[i];

       if(flux) {       
	  PDL_Double det = tmp[ndims*ndims];
          for(i=0; i < out->dims[ndims]; i++) {
            *dat = *(ac++) / wgt * det;
            dat += out->dimincs[ndims];
	  }
       } else {
	  for(i=0; i < out->dims[ndims]; i++) {
           *dat = *(ac++) / wgt;
           dat += out->dimincs[ndims];
          }
       }
     }

     /* End of code for normal pixels */
   } else {       
     /* The pixel was ludicrously huge -- just set this pixel to nan */
     PDL_Short *dat = out->data;
      for(i=0;i<ndims;i++)
	dat += out->dimincs[i] * ovec[i];
      for(i=0;i<out->dims[ndims];i++) {
	*dat = badval;          /* Should handle bad values too -- not yet */
        dat += out->dimincs[ndims];
      }
   }

   /* Increment the pixel counter */
   {
     PDL_Long *aptr = ovec;
     for(i=0;
	     (i<ndims) &&
             (map_ptr += map->dimincs[i+1]) &&  /* Funky pre-test increment */
 	     (++(ovec[i]) >= out->dims[i]);     /* Actual carry test */
	 i++) {
	ovec[i] = 0;
	map_ptr -= out->dims[i] * map->dimincs[i+1];
     }
    }
  } while(i<ndims);



}	/* THREADLOOPEND */
	 k0_datap += __tinc0_0;

	 } k0_datap += __tinc1_0
	     			     - __tinc0_0 *
				       __tdims0;

	} k0_datap -= __tinc1_0 *
     				  __tdims1;
 k0_datap -= __offsp[0];

      } while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));
 	} break; case PDL_US: {
	PDL_Ushort * k0_datap = ((PDL_Ushort *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Ushort * k0_physdatap = ((PDL_Ushort *)((__privtrans->pdls[0])->data));

	/* THREADLOOPBEGIN */
 if(PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata,
 	__tr)) return;
   do { register int __tind1=0,__tind2=0;
        register int __tnpdls = __privtrans->__pdlthread.npdls;
      register int __tdims1 = __privtrans->__pdlthread.dims[1];
      register int __tdims0 = __privtrans->__pdlthread.dims[0];
      register int *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
 register int __tinc0_0 = __privtrans->__pdlthread.incs[0];register int __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];k0_datap += __offsp[0];

	for(__tind2=0; __tind2<__tdims1 ; __tind2++) {
	 for(__tind1=0; __tind1<__tdims0 ; __tind1++) {
	  /* This is the tightest threadloop. Make sure inside is optimal. */
{
/*
 * Pixel interpolation & averaging code
 * 
 * Calls a common coordinate-transformation block (see following hdr)
 * that isn't dependent on the type of the input variable.
 *
 * The inputs are SVs to avoid hassling with threadloops; threading 
 * is handled internally.  To simplify the threading business, any 
 * thread dimensions should all be collapsed to a single one by the
 * perl front-end.
 *
 */

 short ndims;           /* Number of dimensions we're working in    */
 PDL_Double *tmp;           /* Workspace for prefrobnication            */
 PDL_Long  *ovec;           /* output pixel loop vector                 */
 PDL_Long  *ivec;           /* input pixel loop vector                  */
 PDL_Long  *ibvec;          /* input pixel base offset vector           */
 PDL_Double *dvec;          /* Residual vector for linearization        */
 PDL_Double *tvec;          /* Temporary floating-point vector          */
 PDL_Double *acc;           /* Threaded accumulator                     */
 char   *bounds;        /* Boundary condition packed string         */
 char   method;         /* Method identifier (gets one of 'h','g')  */
 PDL_Long   big;            /* Max size of input footprint for each pix */
 PDL_Double blur;           /* Scaling of filter                        */
 PDL_Double sv_min;         /* minimum singular value                   */
 char flux;             /* Flag to indicate flux conservation       */
 PDL_Double *map_ptr;
 PDL_Long i, j;
 PDL_Ushort badval = sqrt(-1);

 pdl *in  = PDL->SvPDLV(__privtrans->in);
 pdl *out = PDL->SvPDLV(__privtrans->out);
 pdl *map = PDL->SvPDLV(__privtrans->map);

 PDL->make_physical(in);
 PDL->make_physical(out);
 PDL->make_physical(map);

 ndims = map->ndims -1;

  /***************************************************************************/
  /**  Check that the dimensionalities are consistent.  This is             **/
  /**  allegedly done already in the perl part, but shouldn't cost more     **/
  /**  than a few hundred clock cycles -- cheap at twice the price.         **/
  /**                                                                       **/
  /**/ if(map->ndims != out->ndims)                                        /**/
  /**/  barf("%s", "Bug in map: index dims aren't consistent\n");          /**/
  /**/ for(i=0;i<out->ndims-1;i++) {                                       /**/
  /**/   static char buf[100];                                             /**/
  /**/   if(map->dims[i+1] != out->dims[i]) {                              /**/
  /**/     sprintf(buf,"Bug in map: dim %d is %d; expected %d\n",          /**/
  /**/                 i,map->dims[i+1],out->dims[i]);                     /**/
  /**/     barf("%s", buf);                                                /**/
  /**/   }                                                                 /**/
  /**/ }                                                                   /**/
  /**/ if(map->dims[0] != in->ndims - 1)                                   /**/
  /**/   barf("%s", "Bug in map - index vec - input mismatch\n");          /**/
  /**/ if(out->dims[out->ndims-1] != in->dims[in->ndims-1])                /**/
  /**/   barf("%s", "Bug in map:  thread dimension error\n");              /**/
  /***************************************************************************/

 /* 
  * Allocate all our dynamic workspaces at once...
 /* */
 ovec = (PDL_Long *)(PDL->smalloc( (STRLEN)
	          	      ( sizeof(PDL_Long)   * 3 * ndims
                              + sizeof(PDL_Double) * (3*ndims*ndims + 3*ndims)
                              + sizeof(PDL_Double) * in->dims[ndims] 
                              + sizeof(char) * ndims )
		             )
		);
 ivec =            &(ovec[ndims]); 
 ibvec =           &(ivec[ndims]);
 dvec = (PDL_Double *)(&(ibvec[ndims]));
 tvec =            &(dvec[ndims]);
 acc  =            &(tvec[ndims]);
 tmp  =            &(acc[in->dims[ndims]]);
 bounds = (char *)(&(tmp [3*ndims*ndims+ndims]));


/***
 * Fill in the boundary condition array
 * (cut-and-pasted from the range() code...)
 */
 {
  char *bstr;
  STRLEN blen;
  bstr = SvPV(__privtrans->boundary,blen);

  if(blen == 0) {
    /* If no boundary is specified then every dim gets truncated */
    int i;
    for (i=0;i<ndims;i++) 
      bounds[i] = 1;
  } else {
    int i;
    for(i=0;i<ndims;i++) {
      switch(bstr[i < blen ? i : blen-1 ]) {
      case '0': case 'f': case 'F':               /* forbid */
	bounds[i] = 0;
	break;
      case '1': case 't': case 'T':               /* truncate */
	bounds[i] = 1;
	break;
      case '2': case 'e': case 'E':               /* extend */
	bounds[i] = 2;
	break;
      case '3': case 'p': case 'P':               /* periodic */
	bounds[i] = 3;
	break;
      case '4': case 'm': case 'M':               /* mirror */
	bounds[i] = 4;
	break;
      default:
	{
	  char buf[BUFSIZ];
	  sprintf(buf,"Error in map: Unknown boundary condition '%c'",bstr[i]);
	  barf("%s", buf);
	}
	break;
      }
    }
  }
 }  

/***
 * Parse out the 'method', 'big', 'blur', and 'sv_min' arguments
 */
 {
  char *mstr;
  STRLEN mlen;
  mstr = SvPV(__privtrans->method,mlen);

  if(mlen==0) 
	method = 'h';
  else switch(*mstr) {
	case 'h': case 'H': 
		method = 'h'; break;
        case 'g': case 'G': 
	case 'j': case 'J': 
		method = 'g'; break;
        default: 
	   {
            char err[80];
            sprintf(err,"Bug in map: unknown method '%c'",*mstr);
	    barf("%s", err);
           }
           break;
	}
 }
 big    = labs((PDL_Long)   (SvNV(__privtrans->big))); 
 blur   = fabs((PDL_Double) (SvNV(__privtrans->blur)));
 sv_min = fabs((PDL_Double) (SvNV(__privtrans->sv_min)));
 flux   = (SvNV(__privtrans->flux) != 0);

 /* End of initialization */
 /*************************************************************/
 /* Start of Real Work */
 	
 /* Initialize coordinate vector and map offset
  */
 for(i=0;i<ndims;i++)
	ovec[i] = 0;
 map_ptr = (PDL_Double *)(map->data);

 /* Main pixel loop */
 do {
   PDL_Long psize;
   PDL_Double wgt;

   /* Prefrobnicate the transformation matrix  */
   psize = (PDL_Long)(blur * PDL_xform_aux(map, ovec, tmp, sv_min) + 0.5 )+1;
   if(psize <= big) {
     /* 
      * Use the prefrobnicated matrix to generate a local linearization 
      * dvec gets the delta; ibvec gets the base. 
      */
     {
       PDL_Double *mp = map_ptr;
       for (i=0;i<ndims;i++) {
  	dvec[i]  = *mp - ( ibvec[i] = (PDL_Long)(*mp + 0.5));   /* assignment */
  	mp += map->dimincs[0];
       }
     }
  
     /* 
      * Initialize input delta vector
      */
     for(i=0;i<ndims;i++)
  	ivec[i] = - psize;
  
     /* 
      * Initialize accumulators
      */
     {
       PDL_Double *ac = acc;
       for(i=0; i < in->dims[ndims]; i++)
  	*(ac++) = 0.0;
     }
     wgt = 1.0e-9;  /* negligible but nonzero */
    
     do {  /* Input accumulation loop */
       int bound_ok = 1;
       PDL_Long i_off = 0;
  
       /* Find the offset for the current input point, applying boundaries */
  
       for(i=0; i<ndims && bound_ok; i++) {
         j = ivec[i] + ibvec[i];
         if(j < 0 || j >= in->dims[i]) {
           switch(bounds[i]) {
             case 0: /* no breakage allowed */
               barf("%s", "index out-of-bounds in map");
               break;
             case 1: /* truncation */
               bound_ok = 0;
               break;
             case 2: /* extension -- crop */
               if(j<0)
                 j = 0;
               else if(j>= in->dims[i])
                 j = in->dims[i] - 1;
               break;
             case 3: /* periodic -- mod it */
               j %= in->dims[i];
               if(j<0)
                 j += in->dims[i];
               break;
             case 4: /* mirror -- reflect off the edges */
               j += in->dims[i];
               j %= (in->dims[i] * 2);
               if(j < 0) 
                 j += in->dims[i] * 2;
               j -= in->dims[i];
               if(j < 0) {
                 j *= -1;
                 j -= 1;
               }
               break;
             default:
               barf("%s", "Unknown boundary condition in map -- bug alert!");
               break;
           }
         }
         i_off += in->dimincs[i] * j;
       }
  
       {  /* convenience block for bounds handling and data weighting */
         PDL_Double alpha = 1.0;
         PDL_Double *ap = tvec;
         PDL_Double *bp = dvec;
         PDL_Double *cp;
         PDL_Long *ip   = ivec;
  
         for(i=0; i<ndims; i++)
           *(ap++) = *(ip++) - *(bp++);
       
       /* Calculate the linearization-transformed point, and 
        * infer a weighting from it.  Use the per-dimension Hanning 
        * window or a radial Gaussian.
        */
         cp = tmp;
        
         switch(method) {
            PDL_Double dd;
  
  	case 'h':
  	       for(i=0; i<ndims; i++) {
  	         dd = 0;
  	         ap = tvec;
  	         for(j=0;j<ndims; j++)
  	             dd += *(ap++) * *(cp++);
  	         dd = fabs(dd) / blur;
  	         if( dd > 1 ) {
  	             alpha = 0;
  	             i = ndims;
  	         } else 
  	             alpha *= (0.5 + 0.5 * cos( dd * 3.1415926536 ));            
  	       }
   	      break;
  	case 'g':
                {PDL_Double sum = 0;
  
  	       for(i=0; i<ndims; i++) {
  	         dd = 0;
  	         ap = tvec;
  	          for(j=0;j<ndims; j++)
  	             dd += *(ap++) * *(cp++);
  	          dd /= blur;
  	 	  sum += dd * dd;
  		  if(sum > 4) /* 2 pixels -- four half-widths */
  		    i = ndims; /* exit early if this pixel is too far outside the footprint of the ideal point */
  	       }
  	       
   	       if(sum > 4)	
  		  alpha = 0;
  	       else
  		  alpha = exp(-sum * 1.386294); /* Gaussian, rt(2)-pix HWHM */
  	     }
   	      break;
  	 default: 
  	     {
                 char buf[80];
                  sprintf(buf,"This can't happen: method='%c'",method);
  	        barf("%s", buf);
  	     }
  	}
  
  
        /* We've got the weighting, now accumulate the values as needed... */
         wgt += alpha;
       
       if(bound_ok)
         { 
          PDL_Double *ac = acc;
          PDL_Ushort *dat = ((PDL_Ushort *)(in->data)) + i_off;
          for( i=0; i < out->dims[ndims]; i++ ) {
               *(ac++) += *dat * alpha;
               dat += in->dimincs[ndims];
          }
         }/* end of bound_ok check */

       }  /* end of data collection convenience block */
       
       /* Advance input accumulation loop */
       for(i=0; 
             (i < ndims) &&
             (++(ivec[i]) > psize);
           i++) {
          ivec[i] = -psize;
       }
     } while(i<ndims);  /* end of total data accumulation loop */
     
     {
       PDL_Double *ac = acc;
       PDL_Ushort *dat = out->data;
       
       for(i=0;i<ndims;i++) 
         dat += out->dimincs[i] * ovec[i];

       if(flux) {       
	  PDL_Double det = tmp[ndims*ndims];
          for(i=0; i < out->dims[ndims]; i++) {
            *dat = *(ac++) / wgt * det;
            dat += out->dimincs[ndims];
	  }
       } else {
	  for(i=0; i < out->dims[ndims]; i++) {
           *dat = *(ac++) / wgt;
           dat += out->dimincs[ndims];
          }
       }
     }

     /* End of code for normal pixels */
   } else {       
     /* The pixel was ludicrously huge -- just set this pixel to nan */
     PDL_Ushort *dat = out->data;
      for(i=0;i<ndims;i++)
	dat += out->dimincs[i] * ovec[i];
      for(i=0;i<out->dims[ndims];i++) {
	*dat = badval;          /* Should handle bad values too -- not yet */
        dat += out->dimincs[ndims];
      }
   }

   /* Increment the pixel counter */
   {
     PDL_Long *aptr = ovec;
     for(i=0;
	     (i<ndims) &&
             (map_ptr += map->dimincs[i+1]) &&  /* Funky pre-test increment */
 	     (++(ovec[i]) >= out->dims[i]);     /* Actual carry test */
	 i++) {
	ovec[i] = 0;
	map_ptr -= out->dims[i] * map->dimincs[i+1];
     }
    }
  } while(i<ndims);



}	/* THREADLOOPEND */
	 k0_datap += __tinc0_0;

	 } k0_datap += __tinc1_0
	     			     - __tinc0_0 *
				       __tdims0;

	} k0_datap -= __tinc1_0 *
     				  __tdims1;
 k0_datap -= __offsp[0];

      } while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));
 	} break; case PDL_L: {
	PDL_Long * k0_datap = ((PDL_Long *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Long * k0_physdatap = ((PDL_Long *)((__privtrans->pdls[0])->data));

	/* THREADLOOPBEGIN */
 if(PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata,
 	__tr)) return;
   do { register int __tind1=0,__tind2=0;
        register int __tnpdls = __privtrans->__pdlthread.npdls;
      register int __tdims1 = __privtrans->__pdlthread.dims[1];
      register int __tdims0 = __privtrans->__pdlthread.dims[0];
      register int *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
 register int __tinc0_0 = __privtrans->__pdlthread.incs[0];register int __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];k0_datap += __offsp[0];

	for(__tind2=0; __tind2<__tdims1 ; __tind2++) {
	 for(__tind1=0; __tind1<__tdims0 ; __tind1++) {
	  /* This is the tightest threadloop. Make sure inside is optimal. */
{
/*
 * Pixel interpolation & averaging code
 * 
 * Calls a common coordinate-transformation block (see following hdr)
 * that isn't dependent on the type of the input variable.
 *
 * The inputs are SVs to avoid hassling with threadloops; threading 
 * is handled internally.  To simplify the threading business, any 
 * thread dimensions should all be collapsed to a single one by the
 * perl front-end.
 *
 */

 short ndims;           /* Number of dimensions we're working in    */
 PDL_Double *tmp;           /* Workspace for prefrobnication            */
 PDL_Long  *ovec;           /* output pixel loop vector                 */
 PDL_Long  *ivec;           /* input pixel loop vector                  */
 PDL_Long  *ibvec;          /* input pixel base offset vector           */
 PDL_Double *dvec;          /* Residual vector for linearization        */
 PDL_Double *tvec;          /* Temporary floating-point vector          */
 PDL_Double *acc;           /* Threaded accumulator                     */
 char   *bounds;        /* Boundary condition packed string         */
 char   method;         /* Method identifier (gets one of 'h','g')  */
 PDL_Long   big;            /* Max size of input footprint for each pix */
 PDL_Double blur;           /* Scaling of filter                        */
 PDL_Double sv_min;         /* minimum singular value                   */
 char flux;             /* Flag to indicate flux conservation       */
 PDL_Double *map_ptr;
 PDL_Long i, j;
 PDL_Long badval = sqrt(-1);

 pdl *in  = PDL->SvPDLV(__privtrans->in);
 pdl *out = PDL->SvPDLV(__privtrans->out);
 pdl *map = PDL->SvPDLV(__privtrans->map);

 PDL->make_physical(in);
 PDL->make_physical(out);
 PDL->make_physical(map);

 ndims = map->ndims -1;

  /***************************************************************************/
  /**  Check that the dimensionalities are consistent.  This is             **/
  /**  allegedly done already in the perl part, but shouldn't cost more     **/
  /**  than a few hundred clock cycles -- cheap at twice the price.         **/
  /**                                                                       **/
  /**/ if(map->ndims != out->ndims)                                        /**/
  /**/  barf("%s", "Bug in map: index dims aren't consistent\n");          /**/
  /**/ for(i=0;i<out->ndims-1;i++) {                                       /**/
  /**/   static char buf[100];                                             /**/
  /**/   if(map->dims[i+1] != out->dims[i]) {                              /**/
  /**/     sprintf(buf,"Bug in map: dim %d is %d; expected %d\n",          /**/
  /**/                 i,map->dims[i+1],out->dims[i]);                     /**/
  /**/     barf("%s", buf);                                                /**/
  /**/   }                                                                 /**/
  /**/ }                                                                   /**/
  /**/ if(map->dims[0] != in->ndims - 1)                                   /**/
  /**/   barf("%s", "Bug in map - index vec - input mismatch\n");          /**/
  /**/ if(out->dims[out->ndims-1] != in->dims[in->ndims-1])                /**/
  /**/   barf("%s", "Bug in map:  thread dimension error\n");              /**/
  /***************************************************************************/

 /* 
  * Allocate all our dynamic workspaces at once...
 /* */
 ovec = (PDL_Long *)(PDL->smalloc( (STRLEN)
	          	      ( sizeof(PDL_Long)   * 3 * ndims
                              + sizeof(PDL_Double) * (3*ndims*ndims + 3*ndims)
                              + sizeof(PDL_Double) * in->dims[ndims] 
                              + sizeof(char) * ndims )
		             )
		);
 ivec =            &(ovec[ndims]); 
 ibvec =           &(ivec[ndims]);
 dvec = (PDL_Double *)(&(ibvec[ndims]));
 tvec =            &(dvec[ndims]);
 acc  =            &(tvec[ndims]);
 tmp  =            &(acc[in->dims[ndims]]);
 bounds = (char *)(&(tmp [3*ndims*ndims+ndims]));


/***
 * Fill in the boundary condition array
 * (cut-and-pasted from the range() code...)
 */
 {
  char *bstr;
  STRLEN blen;
  bstr = SvPV(__privtrans->boundary,blen);

  if(blen == 0) {
    /* If no boundary is specified then every dim gets truncated */
    int i;
    for (i=0;i<ndims;i++) 
      bounds[i] = 1;
  } else {
    int i;
    for(i=0;i<ndims;i++) {
      switch(bstr[i < blen ? i : blen-1 ]) {
      case '0': case 'f': case 'F':               /* forbid */
	bounds[i] = 0;
	break;
      case '1': case 't': case 'T':               /* truncate */
	bounds[i] = 1;
	break;
      case '2': case 'e': case 'E':               /* extend */
	bounds[i] = 2;
	break;
      case '3': case 'p': case 'P':               /* periodic */
	bounds[i] = 3;
	break;
      case '4': case 'm': case 'M':               /* mirror */
	bounds[i] = 4;
	break;
      default:
	{
	  char buf[BUFSIZ];
	  sprintf(buf,"Error in map: Unknown boundary condition '%c'",bstr[i]);
	  barf("%s", buf);
	}
	break;
      }
    }
  }
 }  

/***
 * Parse out the 'method', 'big', 'blur', and 'sv_min' arguments
 */
 {
  char *mstr;
  STRLEN mlen;
  mstr = SvPV(__privtrans->method,mlen);

  if(mlen==0) 
	method = 'h';
  else switch(*mstr) {
	case 'h': case 'H': 
		method = 'h'; break;
        case 'g': case 'G': 
	case 'j': case 'J': 
		method = 'g'; break;
        default: 
	   {
            char err[80];
            sprintf(err,"Bug in map: unknown method '%c'",*mstr);
	    barf("%s", err);
           }
           break;
	}
 }
 big    = labs((PDL_Long)   (SvNV(__privtrans->big))); 
 blur   = fabs((PDL_Double) (SvNV(__privtrans->blur)));
 sv_min = fabs((PDL_Double) (SvNV(__privtrans->sv_min)));
 flux   = (SvNV(__privtrans->flux) != 0);

 /* End of initialization */
 /*************************************************************/
 /* Start of Real Work */
 	
 /* Initialize coordinate vector and map offset
  */
 for(i=0;i<ndims;i++)
	ovec[i] = 0;
 map_ptr = (PDL_Double *)(map->data);

 /* Main pixel loop */
 do {
   PDL_Long psize;
   PDL_Double wgt;

   /* Prefrobnicate the transformation matrix  */
   psize = (PDL_Long)(blur * PDL_xform_aux(map, ovec, tmp, sv_min) + 0.5 )+1;
   if(psize <= big) {
     /* 
      * Use the prefrobnicated matrix to generate a local linearization 
      * dvec gets the delta; ibvec gets the base. 
      */
     {
       PDL_Double *mp = map_ptr;
       for (i=0;i<ndims;i++) {
  	dvec[i]  = *mp - ( ibvec[i] = (PDL_Long)(*mp + 0.5));   /* assignment */
  	mp += map->dimincs[0];
       }
     }
  
     /* 
      * Initialize input delta vector
      */
     for(i=0;i<ndims;i++)
  	ivec[i] = - psize;
  
     /* 
      * Initialize accumulators
      */
     {
       PDL_Double *ac = acc;
       for(i=0; i < in->dims[ndims]; i++)
  	*(ac++) = 0.0;
     }
     wgt = 1.0e-9;  /* negligible but nonzero */
    
     do {  /* Input accumulation loop */
       int bound_ok = 1;
       PDL_Long i_off = 0;
  
       /* Find the offset for the current input point, applying boundaries */
  
       for(i=0; i<ndims && bound_ok; i++) {
         j = ivec[i] + ibvec[i];
         if(j < 0 || j >= in->dims[i]) {
           switch(bounds[i]) {
             case 0: /* no breakage allowed */
               barf("%s", "index out-of-bounds in map");
               break;
             case 1: /* truncation */
               bound_ok = 0;
               break;
             case 2: /* extension -- crop */
               if(j<0)
                 j = 0;
               else if(j>= in->dims[i])
                 j = in->dims[i] - 1;
               break;
             case 3: /* periodic -- mod it */
               j %= in->dims[i];
               if(j<0)
                 j += in->dims[i];
               break;
             case 4: /* mirror -- reflect off the edges */
               j += in->dims[i];
               j %= (in->dims[i] * 2);
               if(j < 0) 
                 j += in->dims[i] * 2;
               j -= in->dims[i];
               if(j < 0) {
                 j *= -1;
                 j -= 1;
               }
               break;
             default:
               barf("%s", "Unknown boundary condition in map -- bug alert!");
               break;
           }
         }
         i_off += in->dimincs[i] * j;
       }
  
       {  /* convenience block for bounds handling and data weighting */
         PDL_Double alpha = 1.0;
         PDL_Double *ap = tvec;
         PDL_Double *bp = dvec;
         PDL_Double *cp;
         PDL_Long *ip   = ivec;
  
         for(i=0; i<ndims; i++)
           *(ap++) = *(ip++) - *(bp++);
       
       /* Calculate the linearization-transformed point, and 
        * infer a weighting from it.  Use the per-dimension Hanning 
        * window or a radial Gaussian.
        */
         cp = tmp;
        
         switch(method) {
            PDL_Double dd;
  
  	case 'h':
  	       for(i=0; i<ndims; i++) {
  	         dd = 0;
  	         ap = tvec;
  	         for(j=0;j<ndims; j++)
  	             dd += *(ap++) * *(cp++);
  	         dd = fabs(dd) / blur;
  	         if( dd > 1 ) {
  	             alpha = 0;
  	             i = ndims;
  	         } else 
  	             alpha *= (0.5 + 0.5 * cos( dd * 3.1415926536 ));            
  	       }
   	      break;
  	case 'g':
                {PDL_Double sum = 0;
  
  	       for(i=0; i<ndims; i++) {
  	         dd = 0;
  	         ap = tvec;
  	          for(j=0;j<ndims; j++)
  	             dd += *(ap++) * *(cp++);
  	          dd /= blur;
  	 	  sum += dd * dd;
  		  if(sum > 4) /* 2 pixels -- four half-widths */
  		    i = ndims; /* exit early if this pixel is too far outside the footprint of the ideal point */
  	       }
  	       
   	       if(sum > 4)	
  		  alpha = 0;
  	       else
  		  alpha = exp(-sum * 1.386294); /* Gaussian, rt(2)-pix HWHM */
  	     }
   	      break;
  	 default: 
  	     {
                 char buf[80];
                  sprintf(buf,"This can't happen: method='%c'",method);
  	        barf("%s", buf);
  	     }
  	}
  
  
        /* We've got the weighting, now accumulate the values as needed... */
         wgt += alpha;
       
       if(bound_ok)
         { 
          PDL_Double *ac = acc;
          PDL_Long *dat = ((PDL_Long *)(in->data)) + i_off;
          for( i=0; i < out->dims[ndims]; i++ ) {
               *(ac++) += *dat * alpha;
               dat += in->dimincs[ndims];
          }
         }/* end of bound_ok check */

       }  /* end of data collection convenience block */
       
       /* Advance input accumulation loop */
       for(i=0; 
             (i < ndims) &&
             (++(ivec[i]) > psize);
           i++) {
          ivec[i] = -psize;
       }
     } while(i<ndims);  /* end of total data accumulation loop */
     
     {
       PDL_Double *ac = acc;
       PDL_Long *dat = out->data;
       
       for(i=0;i<ndims;i++) 
         dat += out->dimincs[i] * ovec[i];

       if(flux) {       
	  PDL_Double det = tmp[ndims*ndims];
          for(i=0; i < out->dims[ndims]; i++) {
            *dat = *(ac++) / wgt * det;
            dat += out->dimincs[ndims];
	  }
       } else {
	  for(i=0; i < out->dims[ndims]; i++) {
           *dat = *(ac++) / wgt;
           dat += out->dimincs[ndims];
          }
       }
     }

     /* End of code for normal pixels */
   } else {       
     /* The pixel was ludicrously huge -- just set this pixel to nan */
     PDL_Long *dat = out->data;
      for(i=0;i<ndims;i++)
	dat += out->dimincs[i] * ovec[i];
      for(i=0;i<out->dims[ndims];i++) {
	*dat = badval;          /* Should handle bad values too -- not yet */
        dat += out->dimincs[ndims];
      }
   }

   /* Increment the pixel counter */
   {
     PDL_Long *aptr = ovec;
     for(i=0;
	     (i<ndims) &&
             (map_ptr += map->dimincs[i+1]) &&  /* Funky pre-test increment */
 	     (++(ovec[i]) >= out->dims[i]);     /* Actual carry test */
	 i++) {
	ovec[i] = 0;
	map_ptr -= out->dims[i] * map->dimincs[i+1];
     }
    }
  } while(i<ndims);



}	/* THREADLOOPEND */
	 k0_datap += __tinc0_0;

	 } k0_datap += __tinc1_0
	     			     - __tinc0_0 *
				       __tdims0;

	} k0_datap -= __tinc1_0 *
     				  __tdims1;
 k0_datap -= __offsp[0];

      } while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));
 	} break; case PDL_LL: {
	PDL_LongLong * k0_datap = ((PDL_LongLong *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_LongLong * k0_physdatap = ((PDL_LongLong *)((__privtrans->pdls[0])->data));

	/* THREADLOOPBEGIN */
 if(PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata,
 	__tr)) return;
   do { register int __tind1=0,__tind2=0;
        register int __tnpdls = __privtrans->__pdlthread.npdls;
      register int __tdims1 = __privtrans->__pdlthread.dims[1];
      register int __tdims0 = __privtrans->__pdlthread.dims[0];
      register int *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
 register int __tinc0_0 = __privtrans->__pdlthread.incs[0];register int __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];k0_datap += __offsp[0];

	for(__tind2=0; __tind2<__tdims1 ; __tind2++) {
	 for(__tind1=0; __tind1<__tdims0 ; __tind1++) {
	  /* This is the tightest threadloop. Make sure inside is optimal. */
{
/*
 * Pixel interpolation & averaging code
 * 
 * Calls a common coordinate-transformation block (see following hdr)
 * that isn't dependent on the type of the input variable.
 *
 * The inputs are SVs to avoid hassling with threadloops; threading 
 * is handled internally.  To simplify the threading business, any 
 * thread dimensions should all be collapsed to a single one by the
 * perl front-end.
 *
 */

 short ndims;           /* Number of dimensions we're working in    */
 PDL_Double *tmp;           /* Workspace for prefrobnication            */
 PDL_Long  *ovec;           /* output pixel loop vector                 */
 PDL_Long  *ivec;           /* input pixel loop vector                  */
 PDL_Long  *ibvec;          /* input pixel base offset vector           */
 PDL_Double *dvec;          /* Residual vector for linearization        */
 PDL_Double *tvec;          /* Temporary floating-point vector          */
 PDL_Double *acc;           /* Threaded accumulator                     */
 char   *bounds;        /* Boundary condition packed string         */
 char   method;         /* Method identifier (gets one of 'h','g')  */
 PDL_Long   big;            /* Max size of input footprint for each pix */
 PDL_Double blur;           /* Scaling of filter                        */
 PDL_Double sv_min;         /* minimum singular value                   */
 char flux;             /* Flag to indicate flux conservation       */
 PDL_Double *map_ptr;
 PDL_Long i, j;
 PDL_LongLong badval = sqrt(-1);

 pdl *in  = PDL->SvPDLV(__privtrans->in);
 pdl *out = PDL->SvPDLV(__privtrans->out);
 pdl *map = PDL->SvPDLV(__privtrans->map);

 PDL->make_physical(in);
 PDL->make_physical(out);
 PDL->make_physical(map);

 ndims = map->ndims -1;

  /***************************************************************************/
  /**  Check that the dimensionalities are consistent.  This is             **/
  /**  allegedly done already in the perl part, but shouldn't cost more     **/
  /**  than a few hundred clock cycles -- cheap at twice the price.         **/
  /**                                                                       **/
  /**/ if(map->ndims != out->ndims)                                        /**/
  /**/  barf("%s", "Bug in map: index dims aren't consistent\n");          /**/
  /**/ for(i=0;i<out->ndims-1;i++) {                                       /**/
  /**/   static char buf[100];                                             /**/
  /**/   if(map->dims[i+1] != out->dims[i]) {                              /**/
  /**/     sprintf(buf,"Bug in map: dim %d is %d; expected %d\n",          /**/
  /**/                 i,map->dims[i+1],out->dims[i]);                     /**/
  /**/     barf("%s", buf);                                                /**/
  /**/   }                                                                 /**/
  /**/ }                                                                   /**/
  /**/ if(map->dims[0] != in->ndims - 1)                                   /**/
  /**/   barf("%s", "Bug in map - index vec - input mismatch\n");          /**/
  /**/ if(out->dims[out->ndims-1] != in->dims[in->ndims-1])                /**/
  /**/   barf("%s", "Bug in map:  thread dimension error\n");              /**/
  /***************************************************************************/

 /* 
  * Allocate all our dynamic workspaces at once...
 /* */
 ovec = (PDL_Long *)(PDL->smalloc( (STRLEN)
	          	      ( sizeof(PDL_Long)   * 3 * ndims
                              + sizeof(PDL_Double) * (3*ndims*ndims + 3*ndims)
                              + sizeof(PDL_Double) * in->dims[ndims] 
                              + sizeof(char) * ndims )
		             )
		);
 ivec =            &(ovec[ndims]); 
 ibvec =           &(ivec[ndims]);
 dvec = (PDL_Double *)(&(ibvec[ndims]));
 tvec =            &(dvec[ndims]);
 acc  =            &(tvec[ndims]);
 tmp  =            &(acc[in->dims[ndims]]);
 bounds = (char *)(&(tmp [3*ndims*ndims+ndims]));


/***
 * Fill in the boundary condition array
 * (cut-and-pasted from the range() code...)
 */
 {
  char *bstr;
  STRLEN blen;
  bstr = SvPV(__privtrans->boundary,blen);

  if(blen == 0) {
    /* If no boundary is specified then every dim gets truncated */
    int i;
    for (i=0;i<ndims;i++) 
      bounds[i] = 1;
  } else {
    int i;
    for(i=0;i<ndims;i++) {
      switch(bstr[i < blen ? i : blen-1 ]) {
      case '0': case 'f': case 'F':               /* forbid */
	bounds[i] = 0;
	break;
      case '1': case 't': case 'T':               /* truncate */
	bounds[i] = 1;
	break;
      case '2': case 'e': case 'E':               /* extend */
	bounds[i] = 2;
	break;
      case '3': case 'p': case 'P':               /* periodic */
	bounds[i] = 3;
	break;
      case '4': case 'm': case 'M':               /* mirror */
	bounds[i] = 4;
	break;
      default:
	{
	  char buf[BUFSIZ];
	  sprintf(buf,"Error in map: Unknown boundary condition '%c'",bstr[i]);
	  barf("%s", buf);
	}
	break;
      }
    }
  }
 }  

/***
 * Parse out the 'method', 'big', 'blur', and 'sv_min' arguments
 */
 {
  char *mstr;
  STRLEN mlen;
  mstr = SvPV(__privtrans->method,mlen);

  if(mlen==0) 
	method = 'h';
  else switch(*mstr) {
	case 'h': case 'H': 
		method = 'h'; break;
        case 'g': case 'G': 
	case 'j': case 'J': 
		method = 'g'; break;
        default: 
	   {
            char err[80];
            sprintf(err,"Bug in map: unknown method '%c'",*mstr);
	    barf("%s", err);
           }
           break;
	}
 }
 big    = labs((PDL_Long)   (SvNV(__privtrans->big))); 
 blur   = fabs((PDL_Double) (SvNV(__privtrans->blur)));
 sv_min = fabs((PDL_Double) (SvNV(__privtrans->sv_min)));
 flux   = (SvNV(__privtrans->flux) != 0);

 /* End of initialization */
 /*************************************************************/
 /* Start of Real Work */
 	
 /* Initialize coordinate vector and map offset
  */
 for(i=0;i<ndims;i++)
	ovec[i] = 0;
 map_ptr = (PDL_Double *)(map->data);

 /* Main pixel loop */
 do {
   PDL_Long psize;
   PDL_Double wgt;

   /* Prefrobnicate the transformation matrix  */
   psize = (PDL_Long)(blur * PDL_xform_aux(map, ovec, tmp, sv_min) + 0.5 )+1;
   if(psize <= big) {
     /* 
      * Use the prefrobnicated matrix to generate a local linearization 
      * dvec gets the delta; ibvec gets the base. 
      */
     {
       PDL_Double *mp = map_ptr;
       for (i=0;i<ndims;i++) {
  	dvec[i]  = *mp - ( ibvec[i] = (PDL_Long)(*mp + 0.5));   /* assignment */
  	mp += map->dimincs[0];
       }
     }
  
     /* 
      * Initialize input delta vector
      */
     for(i=0;i<ndims;i++)
  	ivec[i] = - psize;
  
     /* 
      * Initialize accumulators
      */
     {
       PDL_Double *ac = acc;
       for(i=0; i < in->dims[ndims]; i++)
  	*(ac++) = 0.0;
     }
     wgt = 1.0e-9;  /* negligible but nonzero */
    
     do {  /* Input accumulation loop */
       int bound_ok = 1;
       PDL_Long i_off = 0;
  
       /* Find the offset for the current input point, applying boundaries */
  
       for(i=0; i<ndims && bound_ok; i++) {
         j = ivec[i] + ibvec[i];
         if(j < 0 || j >= in->dims[i]) {
           switch(bounds[i]) {
             case 0: /* no breakage allowed */
               barf("%s", "index out-of-bounds in map");
               break;
             case 1: /* truncation */
               bound_ok = 0;
               break;
             case 2: /* extension -- crop */
               if(j<0)
                 j = 0;
               else if(j>= in->dims[i])
                 j = in->dims[i] - 1;
               break;
             case 3: /* periodic -- mod it */
               j %= in->dims[i];
               if(j<0)
                 j += in->dims[i];
               break;
             case 4: /* mirror -- reflect off the edges */
               j += in->dims[i];
               j %= (in->dims[i] * 2);
               if(j < 0) 
                 j += in->dims[i] * 2;
               j -= in->dims[i];
               if(j < 0) {
                 j *= -1;
                 j -= 1;
               }
               break;
             default:
               barf("%s", "Unknown boundary condition in map -- bug alert!");
               break;
           }
         }
         i_off += in->dimincs[i] * j;
       }
  
       {  /* convenience block for bounds handling and data weighting */
         PDL_Double alpha = 1.0;
         PDL_Double *ap = tvec;
         PDL_Double *bp = dvec;
         PDL_Double *cp;
         PDL_Long *ip   = ivec;
  
         for(i=0; i<ndims; i++)
           *(ap++) = *(ip++) - *(bp++);
       
       /* Calculate the linearization-transformed point, and 
        * infer a weighting from it.  Use the per-dimension Hanning 
        * window or a radial Gaussian.
        */
         cp = tmp;
        
         switch(method) {
            PDL_Double dd;
  
  	case 'h':
  	       for(i=0; i<ndims; i++) {
  	         dd = 0;
  	         ap = tvec;
  	         for(j=0;j<ndims; j++)
  	             dd += *(ap++) * *(cp++);
  	         dd = fabs(dd) / blur;
  	         if( dd > 1 ) {
  	             alpha = 0;
  	             i = ndims;
  	         } else 
  	             alpha *= (0.5 + 0.5 * cos( dd * 3.1415926536 ));            
  	       }
   	      break;
  	case 'g':
                {PDL_Double sum = 0;
  
  	       for(i=0; i<ndims; i++) {
  	         dd = 0;
  	         ap = tvec;
  	          for(j=0;j<ndims; j++)
  	             dd += *(ap++) * *(cp++);
  	          dd /= blur;
  	 	  sum += dd * dd;
  		  if(sum > 4) /* 2 pixels -- four half-widths */
  		    i = ndims; /* exit early if this pixel is too far outside the footprint of the ideal point */
  	       }
  	       
   	       if(sum > 4)	
  		  alpha = 0;
  	       else
  		  alpha = exp(-sum * 1.386294); /* Gaussian, rt(2)-pix HWHM */
  	     }
   	      break;
  	 default: 
  	     {
                 char buf[80];
                  sprintf(buf,"This can't happen: method='%c'",method);
  	        barf("%s", buf);
  	     }
  	}
  
  
        /* We've got the weighting, now accumulate the values as needed... */
         wgt += alpha;
       
       if(bound_ok)
         { 
          PDL_Double *ac = acc;
          PDL_LongLong *dat = ((PDL_LongLong *)(in->data)) + i_off;
          for( i=0; i < out->dims[ndims]; i++ ) {
               *(ac++) += *dat * alpha;
               dat += in->dimincs[ndims];
          }
         }/* end of bound_ok check */

       }  /* end of data collection convenience block */
       
       /* Advance input accumulation loop */
       for(i=0; 
             (i < ndims) &&
             (++(ivec[i]) > psize);
           i++) {
          ivec[i] = -psize;
       }
     } while(i<ndims);  /* end of total data accumulation loop */
     
     {
       PDL_Double *ac = acc;
       PDL_LongLong *dat = out->data;
       
       for(i=0;i<ndims;i++) 
         dat += out->dimincs[i] * ovec[i];

       if(flux) {       
	  PDL_Double det = tmp[ndims*ndims];
          for(i=0; i < out->dims[ndims]; i++) {
            *dat = *(ac++) / wgt * det;
            dat += out->dimincs[ndims];
	  }
       } else {
	  for(i=0; i < out->dims[ndims]; i++) {
           *dat = *(ac++) / wgt;
           dat += out->dimincs[ndims];
          }
       }
     }

     /* End of code for normal pixels */
   } else {       
     /* The pixel was ludicrously huge -- just set this pixel to nan */
     PDL_LongLong *dat = out->data;
      for(i=0;i<ndims;i++)
	dat += out->dimincs[i] * ovec[i];
      for(i=0;i<out->dims[ndims];i++) {
	*dat = badval;          /* Should handle bad values too -- not yet */
        dat += out->dimincs[ndims];
      }
   }

   /* Increment the pixel counter */
   {
     PDL_Long *aptr = ovec;
     for(i=0;
	     (i<ndims) &&
             (map_ptr += map->dimincs[i+1]) &&  /* Funky pre-test increment */
 	     (++(ovec[i]) >= out->dims[i]);     /* Actual carry test */
	 i++) {
	ovec[i] = 0;
	map_ptr -= out->dims[i] * map->dimincs[i+1];
     }
    }
  } while(i<ndims);



}	/* THREADLOOPEND */
	 k0_datap += __tinc0_0;

	 } k0_datap += __tinc1_0
	     			     - __tinc0_0 *
				       __tdims0;

	} k0_datap -= __tinc1_0 *
     				  __tdims1;
 k0_datap -= __offsp[0];

      } while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));
 	} break; case PDL_F: {
	PDL_Float * k0_datap = ((PDL_Float *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Float * k0_physdatap = ((PDL_Float *)((__privtrans->pdls[0])->data));

	/* THREADLOOPBEGIN */
 if(PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata,
 	__tr)) return;
   do { register int __tind1=0,__tind2=0;
        register int __tnpdls = __privtrans->__pdlthread.npdls;
      register int __tdims1 = __privtrans->__pdlthread.dims[1];
      register int __tdims0 = __privtrans->__pdlthread.dims[0];
      register int *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
 register int __tinc0_0 = __privtrans->__pdlthread.incs[0];register int __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];k0_datap += __offsp[0];

	for(__tind2=0; __tind2<__tdims1 ; __tind2++) {
	 for(__tind1=0; __tind1<__tdims0 ; __tind1++) {
	  /* This is the tightest threadloop. Make sure inside is optimal. */
{
/*
 * Pixel interpolation & averaging code
 * 
 * Calls a common coordinate-transformation block (see following hdr)
 * that isn't dependent on the type of the input variable.
 *
 * The inputs are SVs to avoid hassling with threadloops; threading 
 * is handled internally.  To simplify the threading business, any 
 * thread dimensions should all be collapsed to a single one by the
 * perl front-end.
 *
 */

 short ndims;           /* Number of dimensions we're working in    */
 PDL_Double *tmp;           /* Workspace for prefrobnication            */
 PDL_Long  *ovec;           /* output pixel loop vector                 */
 PDL_Long  *ivec;           /* input pixel loop vector                  */
 PDL_Long  *ibvec;          /* input pixel base offset vector           */
 PDL_Double *dvec;          /* Residual vector for linearization        */
 PDL_Double *tvec;          /* Temporary floating-point vector          */
 PDL_Double *acc;           /* Threaded accumulator                     */
 char   *bounds;        /* Boundary condition packed string         */
 char   method;         /* Method identifier (gets one of 'h','g')  */
 PDL_Long   big;            /* Max size of input footprint for each pix */
 PDL_Double blur;           /* Scaling of filter                        */
 PDL_Double sv_min;         /* minimum singular value                   */
 char flux;             /* Flag to indicate flux conservation       */
 PDL_Double *map_ptr;
 PDL_Long i, j;
 PDL_Float badval = sqrt(-1);

 pdl *in  = PDL->SvPDLV(__privtrans->in);
 pdl *out = PDL->SvPDLV(__privtrans->out);
 pdl *map = PDL->SvPDLV(__privtrans->map);

 PDL->make_physical(in);
 PDL->make_physical(out);
 PDL->make_physical(map);

 ndims = map->ndims -1;

  /***************************************************************************/
  /**  Check that the dimensionalities are consistent.  This is             **/
  /**  allegedly done already in the perl part, but shouldn't cost more     **/
  /**  than a few hundred clock cycles -- cheap at twice the price.         **/
  /**                                                                       **/
  /**/ if(map->ndims != out->ndims)                                        /**/
  /**/  barf("%s", "Bug in map: index dims aren't consistent\n");          /**/
  /**/ for(i=0;i<out->ndims-1;i++) {                                       /**/
  /**/   static char buf[100];                                             /**/
  /**/   if(map->dims[i+1] != out->dims[i]) {                              /**/
  /**/     sprintf(buf,"Bug in map: dim %d is %d; expected %d\n",          /**/
  /**/                 i,map->dims[i+1],out->dims[i]);                     /**/
  /**/     barf("%s", buf);                                                /**/
  /**/   }                                                                 /**/
  /**/ }                                                                   /**/
  /**/ if(map->dims[0] != in->ndims - 1)                                   /**/
  /**/   barf("%s", "Bug in map - index vec - input mismatch\n");          /**/
  /**/ if(out->dims[out->ndims-1] != in->dims[in->ndims-1])                /**/
  /**/   barf("%s", "Bug in map:  thread dimension error\n");              /**/
  /***************************************************************************/

 /* 
  * Allocate all our dynamic workspaces at once...
 /* */
 ovec = (PDL_Long *)(PDL->smalloc( (STRLEN)
	          	      ( sizeof(PDL_Long)   * 3 * ndims
                              + sizeof(PDL_Double) * (3*ndims*ndims + 3*ndims)
                              + sizeof(PDL_Double) * in->dims[ndims] 
                              + sizeof(char) * ndims )
		             )
		);
 ivec =            &(ovec[ndims]); 
 ibvec =           &(ivec[ndims]);
 dvec = (PDL_Double *)(&(ibvec[ndims]));
 tvec =            &(dvec[ndims]);
 acc  =            &(tvec[ndims]);
 tmp  =            &(acc[in->dims[ndims]]);
 bounds = (char *)(&(tmp [3*ndims*ndims+ndims]));


/***
 * Fill in the boundary condition array
 * (cut-and-pasted from the range() code...)
 */
 {
  char *bstr;
  STRLEN blen;
  bstr = SvPV(__privtrans->boundary,blen);

  if(blen == 0) {
    /* If no boundary is specified then every dim gets truncated */
    int i;
    for (i=0;i<ndims;i++) 
      bounds[i] = 1;
  } else {
    int i;
    for(i=0;i<ndims;i++) {
      switch(bstr[i < blen ? i : blen-1 ]) {
      case '0': case 'f': case 'F':               /* forbid */
	bounds[i] = 0;
	break;
      case '1': case 't': case 'T':               /* truncate */
	bounds[i] = 1;
	break;
      case '2': case 'e': case 'E':               /* extend */
	bounds[i] = 2;
	break;
      case '3': case 'p': case 'P':               /* periodic */
	bounds[i] = 3;
	break;
      case '4': case 'm': case 'M':               /* mirror */
	bounds[i] = 4;
	break;
      default:
	{
	  char buf[BUFSIZ];
	  sprintf(buf,"Error in map: Unknown boundary condition '%c'",bstr[i]);
	  barf("%s", buf);
	}
	break;
      }
    }
  }
 }  

/***
 * Parse out the 'method', 'big', 'blur', and 'sv_min' arguments
 */
 {
  char *mstr;
  STRLEN mlen;
  mstr = SvPV(__privtrans->method,mlen);

  if(mlen==0) 
	method = 'h';
  else switch(*mstr) {
	case 'h': case 'H': 
		method = 'h'; break;
        case 'g': case 'G': 
	case 'j': case 'J': 
		method = 'g'; break;
        default: 
	   {
            char err[80];
            sprintf(err,"Bug in map: unknown method '%c'",*mstr);
	    barf("%s", err);
           }
           break;
	}
 }
 big    = labs((PDL_Long)   (SvNV(__privtrans->big))); 
 blur   = fabs((PDL_Double) (SvNV(__privtrans->blur)));
 sv_min = fabs((PDL_Double) (SvNV(__privtrans->sv_min)));
 flux   = (SvNV(__privtrans->flux) != 0);

 /* End of initialization */
 /*************************************************************/
 /* Start of Real Work */
 	
 /* Initialize coordinate vector and map offset
  */
 for(i=0;i<ndims;i++)
	ovec[i] = 0;
 map_ptr = (PDL_Double *)(map->data);

 /* Main pixel loop */
 do {
   PDL_Long psize;
   PDL_Double wgt;

   /* Prefrobnicate the transformation matrix  */
   psize = (PDL_Long)(blur * PDL_xform_aux(map, ovec, tmp, sv_min) + 0.5 )+1;
   if(psize <= big) {
     /* 
      * Use the prefrobnicated matrix to generate a local linearization 
      * dvec gets the delta; ibvec gets the base. 
      */
     {
       PDL_Double *mp = map_ptr;
       for (i=0;i<ndims;i++) {
  	dvec[i]  = *mp - ( ibvec[i] = (PDL_Long)(*mp + 0.5));   /* assignment */
  	mp += map->dimincs[0];
       }
     }
  
     /* 
      * Initialize input delta vector
      */
     for(i=0;i<ndims;i++)
  	ivec[i] = - psize;
  
     /* 
      * Initialize accumulators
      */
     {
       PDL_Double *ac = acc;
       for(i=0; i < in->dims[ndims]; i++)
  	*(ac++) = 0.0;
     }
     wgt = 1.0e-9;  /* negligible but nonzero */
    
     do {  /* Input accumulation loop */
       int bound_ok = 1;
       PDL_Long i_off = 0;
  
       /* Find the offset for the current input point, applying boundaries */
  
       for(i=0; i<ndims && bound_ok; i++) {
         j = ivec[i] + ibvec[i];
         if(j < 0 || j >= in->dims[i]) {
           switch(bounds[i]) {
             case 0: /* no breakage allowed */
               barf("%s", "index out-of-bounds in map");
               break;
             case 1: /* truncation */
               bound_ok = 0;
               break;
             case 2: /* extension -- crop */
               if(j<0)
                 j = 0;
               else if(j>= in->dims[i])
                 j = in->dims[i] - 1;
               break;
             case 3: /* periodic -- mod it */
               j %= in->dims[i];
               if(j<0)
                 j += in->dims[i];
               break;
             case 4: /* mirror -- reflect off the edges */
               j += in->dims[i];
               j %= (in->dims[i] * 2);
               if(j < 0) 
                 j += in->dims[i] * 2;
               j -= in->dims[i];
               if(j < 0) {
                 j *= -1;
                 j -= 1;
               }
               break;
             default:
               barf("%s", "Unknown boundary condition in map -- bug alert!");
               break;
           }
         }
         i_off += in->dimincs[i] * j;
       }
  
       {  /* convenience block for bounds handling and data weighting */
         PDL_Double alpha = 1.0;
         PDL_Double *ap = tvec;
         PDL_Double *bp = dvec;
         PDL_Double *cp;
         PDL_Long *ip   = ivec;
  
         for(i=0; i<ndims; i++)
           *(ap++) = *(ip++) - *(bp++);
       
       /* Calculate the linearization-transformed point, and 
        * infer a weighting from it.  Use the per-dimension Hanning 
        * window or a radial Gaussian.
        */
         cp = tmp;
        
         switch(method) {
            PDL_Double dd;
  
  	case 'h':
  	       for(i=0; i<ndims; i++) {
  	         dd = 0;
  	         ap = tvec;
  	         for(j=0;j<ndims; j++)
  	             dd += *(ap++) * *(cp++);
  	         dd = fabs(dd) / blur;
  	         if( dd > 1 ) {
  	             alpha = 0;
  	             i = ndims;
  	         } else 
  	             alpha *= (0.5 + 0.5 * cos( dd * 3.1415926536 ));            
  	       }
   	      break;
  	case 'g':
                {PDL_Double sum = 0;
  
  	       for(i=0; i<ndims; i++) {
  	         dd = 0;
  	         ap = tvec;
  	          for(j=0;j<ndims; j++)
  	             dd += *(ap++) * *(cp++);
  	          dd /= blur;
  	 	  sum += dd * dd;
  		  if(sum > 4) /* 2 pixels -- four half-widths */
  		    i = ndims; /* exit early if this pixel is too far outside the footprint of the ideal point */
  	       }
  	       
   	       if(sum > 4)	
  		  alpha = 0;
  	       else
  		  alpha = exp(-sum * 1.386294); /* Gaussian, rt(2)-pix HWHM */
  	     }
   	      break;
  	 default: 
  	     {
                 char buf[80];
                  sprintf(buf,"This can't happen: method='%c'",method);
  	        barf("%s", buf);
  	     }
  	}
  
  
        /* We've got the weighting, now accumulate the values as needed... */
         wgt += alpha;
       
       if(bound_ok)
         { 
          PDL_Double *ac = acc;
          PDL_Float *dat = ((PDL_Float *)(in->data)) + i_off;
          for( i=0; i < out->dims[ndims]; i++ ) {
               *(ac++) += *dat * alpha;
               dat += in->dimincs[ndims];
          }
         }/* end of bound_ok check */

       }  /* end of data collection convenience block */
       
       /* Advance input accumulation loop */
       for(i=0; 
             (i < ndims) &&
             (++(ivec[i]) > psize);
           i++) {
          ivec[i] = -psize;
       }
     } while(i<ndims);  /* end of total data accumulation loop */
     
     {
       PDL_Double *ac = acc;
       PDL_Float *dat = out->data;
       
       for(i=0;i<ndims;i++) 
         dat += out->dimincs[i] * ovec[i];

       if(flux) {       
	  PDL_Double det = tmp[ndims*ndims];
          for(i=0; i < out->dims[ndims]; i++) {
            *dat = *(ac++) / wgt * det;
            dat += out->dimincs[ndims];
	  }
       } else {
	  for(i=0; i < out->dims[ndims]; i++) {
           *dat = *(ac++) / wgt;
           dat += out->dimincs[ndims];
          }
       }
     }

     /* End of code for normal pixels */
   } else {       
     /* The pixel was ludicrously huge -- just set this pixel to nan */
     PDL_Float *dat = out->data;
      for(i=0;i<ndims;i++)
	dat += out->dimincs[i] * ovec[i];
      for(i=0;i<out->dims[ndims];i++) {
	*dat = badval;          /* Should handle bad values too -- not yet */
        dat += out->dimincs[ndims];
      }
   }

   /* Increment the pixel counter */
   {
     PDL_Long *aptr = ovec;
     for(i=0;
	     (i<ndims) &&
             (map_ptr += map->dimincs[i+1]) &&  /* Funky pre-test increment */
 	     (++(ovec[i]) >= out->dims[i]);     /* Actual carry test */
	 i++) {
	ovec[i] = 0;
	map_ptr -= out->dims[i] * map->dimincs[i+1];
     }
    }
  } while(i<ndims);



}	/* THREADLOOPEND */
	 k0_datap += __tinc0_0;

	 } k0_datap += __tinc1_0
	     			     - __tinc0_0 *
				       __tdims0;

	} k0_datap -= __tinc1_0 *
     				  __tdims1;
 k0_datap -= __offsp[0];

      } while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));
 	} break; case PDL_D: {
	PDL_Double * k0_datap = ((PDL_Double *)(PDL_REPRP_TRANS((__privtrans->pdls[0]),(__privtrans->vtable->per_pdl_flags[0]))));
	PDL_Double * k0_physdatap = ((PDL_Double *)((__privtrans->pdls[0])->data));

	/* THREADLOOPBEGIN */
 if(PDL->startthreadloop(&(__privtrans->__pdlthread),__privtrans->vtable->readdata,
 	__tr)) return;
   do { register int __tind1=0,__tind2=0;
        register int __tnpdls = __privtrans->__pdlthread.npdls;
      register int __tdims1 = __privtrans->__pdlthread.dims[1];
      register int __tdims0 = __privtrans->__pdlthread.dims[0];
      register int *__offsp = PDL->get_threadoffsp(&__privtrans->__pdlthread);
 register int __tinc0_0 = __privtrans->__pdlthread.incs[0];register int __tinc1_0 = __privtrans->__pdlthread.incs[__tnpdls+0];k0_datap += __offsp[0];

	for(__tind2=0; __tind2<__tdims1 ; __tind2++) {
	 for(__tind1=0; __tind1<__tdims0 ; __tind1++) {
	  /* This is the tightest threadloop. Make sure inside is optimal. */
{
/*
 * Pixel interpolation & averaging code
 * 
 * Calls a common coordinate-transformation block (see following hdr)
 * that isn't dependent on the type of the input variable.
 *
 * The inputs are SVs to avoid hassling with threadloops; threading 
 * is handled internally.  To simplify the threading business, any 
 * thread dimensions should all be collapsed to a single one by the
 * perl front-end.
 *
 */

 short ndims;           /* Number of dimensions we're working in    */
 PDL_Double *tmp;           /* Workspace for prefrobnication            */
 PDL_Long  *ovec;           /* output pixel loop vector                 */
 PDL_Long  *ivec;           /* input pixel loop vector                  */
 PDL_Long  *ibvec;          /* input pixel base offset vector           */
 PDL_Double *dvec;          /* Residual vector for linearization        */
 PDL_Double *tvec;          /* Temporary floating-point vector          */
 PDL_Double *acc;           /* Threaded accumulator                     */
 char   *bounds;        /* Boundary condition packed string         */
 char   method;         /* Method identifier (gets one of 'h','g')  */
 PDL_Long   big;            /* Max size of input footprint for each pix */
 PDL_Double blur;           /* Scaling of filter                        */
 PDL_Double sv_min;         /* minimum singular value                   */
 char flux;             /* Flag to indicate flux conservation       */
 PDL_Double *map_ptr;
 PDL_Long i, j;
 PDL_Double badval = sqrt(-1);

 pdl *in  = PDL->SvPDLV(__privtrans->in);
 pdl *out = PDL->SvPDLV(__privtrans->out);
 pdl *map = PDL->SvPDLV(__privtrans->map);

 PDL->make_physical(in);
 PDL->make_physical(out);
 PDL->make_physical(map);

 ndims = map->ndims -1;

  /***************************************************************************/
  /**  Check that the dimensionalities are consistent.  This is             **/
  /**  allegedly done already in the perl part, but shouldn't cost more     **/
  /**  than a few hundred clock cycles -- cheap at twice the price.         **/
  /**                                                                       **/
  /**/ if(map->ndims != out->ndims)                                        /**/
  /**/  barf("%s", "Bug in map: index dims aren't consistent\n");          /**/
  /**/ for(i=0;i<out->ndims-1;i++) {                                       /**/
  /**/   static char buf[100];                                             /**/
  /**/   if(map->dims[i+1] != out->dims[i]) {                              /**/
  /**/     sprintf(buf,"Bug in map: dim %d is %d; expected %d\n",          /**/
  /**/                 i,map->dims[i+1],out->dims[i]);                     /**/
  /**/     barf("%s", buf);                                                /**/
  /**/   }                                                                 /**/
  /**/ }                                                                   /**/
  /**/ if(map->dims[0] != in->ndims - 1)                                   /**/
  /**/   barf("%s", "Bug in map - index vec - input mismatch\n");          /**/
  /**/ if(out->dims[out->ndims-1] != in->dims[in->ndims-1])                /**/
  /**/   barf("%s", "Bug in map:  thread dimension error\n");              /**/
  /***************************************************************************/

 /* 
  * Allocate all our dynamic workspaces at once...
 /* */
 ovec = (PDL_Long *)(PDL->smalloc( (STRLEN)
	          	      ( sizeof(PDL_Long)   * 3 * ndims
                              + sizeof(PDL_Double) * (3*ndims*ndims + 3*ndims)
                              + sizeof(PDL_Double) * in->dims[ndims] 
                              + sizeof(char) * ndims )
		             )
		);
 ivec =            &(ovec[ndims]); 
 ibvec =           &(ivec[ndims]);
 dvec = (PDL_Double *)(&(ibvec[ndims]));
 tvec =            &(dvec[ndims]);
 acc  =            &(tvec[ndims]);
 tmp  =            &(acc[in->dims[ndims]]);
 bounds = (char *)(&(tmp [3*ndims*ndims+ndims]));


/***
 * Fill in the boundary condition array
 * (cut-and-pasted from the range() code...)
 */
 {
  char *bstr;
  STRLEN blen;
  bstr = SvPV(__privtrans->boundary,blen);

  if(blen == 0) {
    /* If no boundary is specified then every dim gets truncated */
    int i;
    for (i=0;i<ndims;i++) 
      bounds[i] = 1;
  } else {
    int i;
    for(i=0;i<ndims;i++) {
      switch(bstr[i < blen ? i : blen-1 ]) {
      case '0': case 'f': case 'F':               /* forbid */
	bounds[i] = 0;
	break;
      case '1': case 't': case 'T':               /* truncate */
	bounds[i] = 1;
	break;
      case '2': case 'e': case 'E':               /* extend */
	bounds[i] = 2;
	break;
      case '3': case 'p': case 'P':               /* periodic */
	bounds[i] = 3;
	break;
      case '4': case 'm': case 'M':               /* mirror */
	bounds[i] = 4;
	break;
      default:
	{
	  char buf[BUFSIZ];
	  sprintf(buf,"Error in map: Unknown boundary condition '%c'",bstr[i]);
	  barf("%s", buf);
	}
	break;
      }
    }
  }
 }  

/***
 * Parse out the 'method', 'big', 'blur', and 'sv_min' arguments
 */
 {
  char *mstr;
  STRLEN mlen;
  mstr = SvPV(__privtrans->method,mlen);

  if(mlen==0) 
	method = 'h';
  else switch(*mstr) {
	case 'h': case 'H': 
		method = 'h'; break;
        case 'g': case 'G': 
	case 'j': case 'J': 
		method = 'g'; break;
        default: 
	   {
            char err[80];
            sprintf(err,"Bug in map: unknown method '%c'",*mstr);
	    barf("%s", err);
           }
           break;
	}
 }
 big    = labs((PDL_Long)   (SvNV(__privtrans->big))); 
 blur   = fabs((PDL_Double) (SvNV(__privtrans->blur)));
 sv_min = fabs((PDL_Double) (SvNV(__privtrans->sv_min)));
 flux   = (SvNV(__privtrans->flux) != 0);

 /* End of initialization */
 /*************************************************************/
 /* Start of Real Work */
 	
 /* Initialize coordinate vector and map offset
  */
 for(i=0;i<ndims;i++)
	ovec[i] = 0;
 map_ptr = (PDL_Double *)(map->data);

 /* Main pixel loop */
 do {
   PDL_Long psize;
   PDL_Double wgt;

   /* Prefrobnicate the transformation matrix  */
   psize = (PDL_Long)(blur * PDL_xform_aux(map, ovec, tmp, sv_min) + 0.5 )+1;
   if(psize <= big) {
     /* 
      * Use the prefrobnicated matrix to generate a local linearization 
      * dvec gets the delta; ibvec gets the base. 
      */
     {
       PDL_Double *mp = map_ptr;
       for (i=0;i<ndims;i++) {
  	dvec[i]  = *mp - ( ibvec[i] = (PDL_Long)(*mp + 0.5));   /* assignment */
  	mp += map->dimincs[0];
       }
     }
  
     /* 
      * Initialize input delta vector
      */
     for(i=0;i<ndims;i++)
  	ivec[i] = - psize;
  
     /* 
      * Initialize accumulators
      */
     {
       PDL_Double *ac = acc;
       for(i=0; i < in->dims[ndims]; i++)
  	*(ac++) = 0.0;
     }
     wgt = 1.0e-9;  /* negligible but nonzero */
    
     do {  /* Input accumulation loop */
       int bound_ok = 1;
       PDL_Long i_off = 0;
  
       /* Find the offset for the current input point, applying boundaries */
  
       for(i=0; i<ndims && bound_ok; i++) {
         j = ivec[i] + ibvec[i];
         if(j < 0 || j >= in->dims[i]) {
           switch(bounds[i]) {
             case 0: /* no breakage allowed */
               barf("%s", "index out-of-bounds in map");
               break;
             case 1: /* truncation */
               bound_ok = 0;
               break;
             case 2: /* extension -- crop */
               if(j<0)
                 j = 0;
               else if(j>= in->dims[i])
                 j = in->dims[i] - 1;
               break;
             case 3: /* periodic -- mod it */
               j %= in->dims[i];
               if(j<0)
                 j += in->dims[i];
               break;
             case 4: /* mirror -- reflect off the edges */
               j += in->dims[i];
               j %= (in->dims[i] * 2);
               if(j < 0) 
                 j += in->dims[i] * 2;
               j -= in->dims[i];
               if(j < 0) {
                 j *= -1;
                 j -= 1;
               }
               break;
             default:
               barf("%s", "Unknown boundary condition in map -- bug alert!");
               break;
           }
         }
         i_off += in->dimincs[i] * j;
       }
  
       {  /* convenience block for bounds handling and data weighting */
         PDL_Double alpha = 1.0;
         PDL_Double *ap = tvec;
         PDL_Double *bp = dvec;
         PDL_Double *cp;
         PDL_Long *ip   = ivec;
  
         for(i=0; i<ndims; i++)
           *(ap++) = *(ip++) - *(bp++);
       
       /* Calculate the linearization-transformed point, and 
        * infer a weighting from it.  Use the per-dimension Hanning 
        * window or a radial Gaussian.
        */
         cp = tmp;
        
         switch(method) {
            PDL_Double dd;
  
  	case 'h':
  	       for(i=0; i<ndims; i++) {
  	         dd = 0;
  	         ap = tvec;
  	         for(j=0;j<ndims; j++)
  	             dd += *(ap++) * *(cp++);
  	         dd = fabs(dd) / blur;
  	         if( dd > 1 ) {
  	             alpha = 0;
  	             i = ndims;
  	         } else 
  	             alpha *= (0.5 + 0.5 * cos( dd * 3.1415926536 ));            
  	       }
   	      break;
  	case 'g':
                {PDL_Double sum = 0;
  
  	       for(i=0; i<ndims; i++) {
  	         dd = 0;
  	         ap = tvec;
  	          for(j=0;j<ndims; j++)
  	             dd += *(ap++) * *(cp++);
  	          dd /= blur;
  	 	  sum += dd * dd;
  		  if(sum > 4) /* 2 pixels -- four half-widths */
  		    i = ndims; /* exit early if this pixel is too far outside the footprint of the ideal point */
  	       }
  	       
   	       if(sum > 4)	
  		  alpha = 0;
  	       else
  		  alpha = exp(-sum * 1.386294); /* Gaussian, rt(2)-pix HWHM */
  	     }
   	      break;
  	 default: 
  	     {
                 char buf[80];
                  sprintf(buf,"This can't happen: method='%c'",method);
  	        barf("%s", buf);
  	     }
  	}
  
  
        /* We've got the weighting, now accumulate the values as needed... */
         wgt += alpha;
       
       if(bound_ok)
         { 
          PDL_Double *ac = acc;
          PDL_Double *dat = ((PDL_Double *)(in->data)) + i_off;
          for( i=0; i < out->dims[ndims]; i++ ) {
               *(ac++) += *dat * alpha;
               dat += in->dimincs[ndims];
          }
         }/* end of bound_ok check */

       }  /* end of data collection convenience block */
       
       /* Advance input accumulation loop */
       for(i=0; 
             (i < ndims) &&
             (++(ivec[i]) > psize);
           i++) {
          ivec[i] = -psize;
       }
     } while(i<ndims);  /* end of total data accumulation loop */
     
     {
       PDL_Double *ac = acc;
       PDL_Double *dat = out->data;
       
       for(i=0;i<ndims;i++) 
         dat += out->dimincs[i] * ovec[i];

       if(flux) {       
	  PDL_Double det = tmp[ndims*ndims];
          for(i=0; i < out->dims[ndims]; i++) {
            *dat = *(ac++) / wgt * det;
            dat += out->dimincs[ndims];
	  }
       } else {
	  for(i=0; i < out->dims[ndims]; i++) {
           *dat = *(ac++) / wgt;
           dat += out->dimincs[ndims];
          }
       }
     }

     /* End of code for normal pixels */
   } else {       
     /* The pixel was ludicrously huge -- just set this pixel to nan */
     PDL_Double *dat = out->data;
      for(i=0;i<ndims;i++)
	dat += out->dimincs[i] * ovec[i];
      for(i=0;i<out->dims[ndims];i++) {
	*dat = badval;          /* Should handle bad values too -- not yet */
        dat += out->dimincs[ndims];
      }
   }

   /* Increment the pixel counter */
   {
     PDL_Long *aptr = ovec;
     for(i=0;
	     (i<ndims) &&
             (map_ptr += map->dimincs[i+1]) &&  /* Funky pre-test increment */
 	     (++(ovec[i]) >= out->dims[i]);     /* Actual carry test */
	 i++) {
	ovec[i] = 0;
	map_ptr -= out->dims[i] * map->dimincs[i+1];
     }
    }
  } while(i<ndims);



}	/* THREADLOOPEND */
	 k0_datap += __tinc0_0;

	 } k0_datap += __tinc1_0
	     			     - __tinc0_0 *
				       __tdims0;

	} k0_datap -= __tinc1_0 *
     				  __tdims1;
 k0_datap -= __offsp[0];

      } while(PDL->iterthreadloop(&__privtrans->__pdlthread,2));
 	break;}
	default:barf("PP INTERNAL ERROR! PLEASE MAKE A BUG REPORT\n");}
}
	}
    }
    



void pdl_map_free(pdl_trans *__tr ) {
	int __dim;
	pdl_map_struct *__privtrans = (pdl_map_struct *) __tr;
	
	{
	    
			PDL_TR_CLRMAGIC(__privtrans);
			SvREFCNT_dec(__privtrans->in);;SvREFCNT_dec(__privtrans->out);;SvREFCNT_dec(__privtrans->map);;SvREFCNT_dec(__privtrans->boundary);;SvREFCNT_dec(__privtrans->method);;SvREFCNT_dec(__privtrans->big);;SvREFCNT_dec(__privtrans->blur);;SvREFCNT_dec(__privtrans->sv_min);;SvREFCNT_dec(__privtrans->flux);;
			if(__privtrans->__ddone) {
				PDL->freethreadloop(&(__privtrans->__pdlthread));
				;
			}
			
	}
    }
    



static char pdl_map_vtable_flags[] =
	 	{ PDL_TPDL_VAFFINE_OK};
	 pdl_transvtable pdl_map_vtable = {
		0,0, 1, 1, pdl_map_vtable_flags,
		pdl_map_redodims, pdl_map_readdata, NULL,
		pdl_map_free,NULL,NULL,pdl_map_copy,NULL,
		sizeof(pdl_map_struct),"pdl_map_vtable",
		NULL
	 };



#line 3273 "Transform.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)    S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage        S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 3415 "Transform.c"

XS_EUPXS(XS_PDL__Transform_set_debugging); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Transform_set_debugging)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "i");
    {
	int	i = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 3271 "Transform.xs"
	RETVAL = __pdl_debugging;
	__pdl_debugging = i;
#line 3431 "Transform.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL__Transform_set_boundscheck); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Transform_set_boundscheck)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "i");
    {
	int	i = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 3280 "Transform.xs"
       if (! 1)
         warn("Bounds checking is disabled for PDL::Transform");
       RETVAL = __pdl_boundscheck;
       __pdl_boundscheck = i;
#line 3454 "Transform.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL__map_int); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__map_int)
{
    dVAR; dXSARGS;
    if (items != 10)
       croak_xs_usage(cv,  "k0, in, out, map, boundary, method, big, blur, sv_min, flux");
    {
	pdl *	k0 = PDL->SvPDLV(ST(0))
;
	SV *	in = ST(1)
;
	SV *	out = ST(2)
;
	SV *	map = ST(3)
;
	SV *	boundary = ST(4)
;
	SV *	method = ST(5)
;
	SV *	big = ST(6)
;
	SV *	blur = ST(7)
;
	SV *	sv_min = ST(8)
;
	SV *	flux = ST(9)
;
#line 3304 "Transform.xs"
 { pdl_map_struct  *__privtrans;
  int badflag_cache = 0;
   __privtrans = malloc(sizeof(*__privtrans));
   PDL_THR_CLRMAGIC(&__privtrans->__pdlthread);
   PDL_TR_SETMAGIC(__privtrans);
   __privtrans->flags = 0;
   __privtrans->__ddone = 0;
   __privtrans->vtable = &pdl_map_vtable;
   __privtrans->freeproc = PDL->trans_mallocfreeproc;
__privtrans->bvalflag = 0;
  badflag_cache = ((k0->state & PDL_BADVAL) > 0);
  if (badflag_cache) __privtrans->bvalflag = 1;
__privtrans->__datatype = 0;if(__privtrans->__datatype < k0->datatype) {
		 	__privtrans->__datatype = k0->datatype;
		    }
if(__privtrans->__datatype == PDL_B) {}
else if(__privtrans->__datatype == PDL_S) {}
else if(__privtrans->__datatype == PDL_U) {}
else if(__privtrans->__datatype == PDL_L) {}
else if(__privtrans->__datatype == PDL_Q) {}
else if(__privtrans->__datatype == PDL_F) {}
else if(__privtrans->__datatype == PDL_D) {}
else __privtrans->__datatype = PDL_D;
if(__privtrans->__datatype != k0->datatype) {
	     k0 = PDL->get_convertedpdl(k0,__privtrans->__datatype);
	  }{(__privtrans->in) = newSVsv(in);(__privtrans->out) = newSVsv(out);(__privtrans->map) = newSVsv(map);(__privtrans->boundary) = newSVsv(boundary);(__privtrans->method) = newSVsv(method);(__privtrans->big) = newSVsv(big);(__privtrans->blur) = newSVsv(blur);(__privtrans->sv_min) = newSVsv(sv_min);(__privtrans->flux) = newSVsv(flux);}/* No flow */__privtrans->__pdlthread.inds = 0;__privtrans->pdls[0] = k0;
PDL->make_trans_mutual((pdl_trans *)__privtrans);
if (badflag_cache) {
}
 XSRETURN(0);
}
#line 3520 "Transform.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_PDL__Transform); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_PDL__Transform)
{
    dVAR; dXSARGS;
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK;

        (void)newXSproto_portable("PDL::Transform::set_debugging", XS_PDL__Transform_set_debugging, file, "$");
        (void)newXSproto_portable("PDL::Transform::set_boundscheck", XS_PDL__Transform_set_boundscheck, file, "$");
        (void)newXSproto_portable("PDL::_map_int", XS_PDL__map_int, file, "$$$$$$$$$$");

    /* Initialisation Section */

#line 3338 "Transform.xs"

   /* Get pointer to structure of core shared C routines */
   /* make sure PDL::Core is loaded */
   perl_require_pv("PDL::Core");
   CoreSV = perl_get_sv("PDL::SHARE",FALSE);  /* SV* value */
#ifndef aTHX_
#define aTHX_
#endif
   if (CoreSV==NULL)
     Perl_croak(aTHX_ "Can't load PDL::Core module");
   PDL = INT2PTR(Core*, SvIV( CoreSV ));  /* Core* value */
   if (PDL->Version != PDL_CORE_VERSION)
     Perl_croak(aTHX_ "PDL::Transform needs to be recompiled against the newly installed PDL");

#line 3566 "Transform.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

